firefox crashes on flash contents when using libflashsupport

Bug #192888 reported by LGB [Gábor Lénárt] on 2008-02-18
954
This bug affects 24 people
Affects Status Importance Assigned to Milestone
firefox (Ubuntu)
Undecided
Mozilla Bugs
Nominated for Dapper by fro1269
Nominated for Gutsy by fro1269
Nominated for Jaunty by fro1269
Hardy
Undecided
Mozilla Bugs
Intrepid
Undecided
Mozilla Bugs
flashplugin-nonfree (Ubuntu)
High
Daniel T Chen
Nominated for Dapper by fro1269
Nominated for Gutsy by fro1269
Nominated for Jaunty by fro1269
Hardy
High
Unassigned
Intrepid
High
Daniel T Chen
ia32-libs (Ubuntu)
High
Stephan Ruegamer
Nominated for Dapper by fro1269
Nominated for Gutsy by fro1269
Nominated for Jaunty by fro1269
Hardy
Undecided
Unassigned
Intrepid
High
Stephan Ruegamer
libflashsupport (Baltix)
Undecided
Unassigned
libflashsupport (Ubuntu)
High
Daniel T Chen
Nominated for Dapper by fro1269
Nominated for Gutsy by fro1269
Nominated for Jaunty by fro1269
Hardy
High
Unassigned
Intrepid
High
Daniel T Chen
linux (Ubuntu)
Undecided
Unassigned
Nominated for Dapper by fro1269
Nominated for Gutsy by fro1269
Nominated for Jaunty by fro1269
Hardy
Undecided
Unassigned
Intrepid
Undecided
Unassigned
pulseaudio (Ubuntu)
High
Unassigned
Nominated for Dapper by fro1269
Nominated for Gutsy by fro1269
Nominated for Jaunty by fro1269
Hardy
High
Unassigned
Intrepid
High
Unassigned

Bug Description

Testcase:

use pulseaudio and libflashsupport together with flashplugin-nonfree in firefox.

1. navigate to youtube video
2. wait till sound plays
3. hit back button
4. hit forward
5. goto 2 if not yet crashed.

the crash sometimes happens after 2 iterations ... and i can't remember that i ever made 10 :) ...

=================

Tested on two machines both with gutsy and hardy (on 32 bit x86): flash content very often crashes firefox (both of firefox-3.0 in hardy and older versions). I've just tried with other browsers, epiphany-browser crashes as well, and even konqueror from KDE (though it's not crashing at a whole, since it may run flash and other plugins as another user or something similar - I think at least - but it reports the crash of flash). I don't know exactly the package I should report this against, but as far as I can remember this issue presents since I started to play with pulseaudio: there is a wrapper lib to allow flash to play sound via PA right, so it CAN BE caused by this single issue instead of problem of the browser or the flash plugin itself?

=================
Workaround for early Hardy adopters:

Manually uninstall the libflashsupport via 'apt-get remove libflashsupport' or synaptic. This is necessary because libflashsupport would not automatically be removed by update-manager when it was changed from a dependent package to a recommended package during the Hardy development cycle.

=================
Update 13/8/08: Hopefully this summary can help clarify the situation and help get this bug fixed!

Since the release of Flash 9, ALSA is the only audio output method supported by Flash (as opposed to earlier releases which had OSS and ESD support built-in). However, to aid with backwards-compatibility, Adobe have provided a simple API to support other audio (and secure transaction) schemes, which can be exposed by using the "libflashsupport" code. You can view the original implementation on Adobe's wiki page, which extends OSS and ESD output to Flash 9: http://labs.adobe.com/wiki/index.php/Flash_Player:Additional_Interface_Support_for_Linux

The version of libflashsupport used in Ubuntu (and most recent distributions that use PulseAudio) is different to the above, as it has been extended to support PulseAudio. You can see the relevant upstream wiki, with a description and link to the git repository: http://www.pulseaudio.org/wiki/FlashPlayer9Solution

The problem that users are experiencing in this bug is that Flash becomes unstable when the libflashsupport API is used; both the original OSS/ESD implementation provided by Adobe and the version adapted for PulseAudio exhibit this instability. The source of the problem is within Flash itself and it is not due to a bug in the modified libflashsupport code. See this PulseAudio bug report: http://www.pulseaudio.org/ticket/267

So what can we do? We can drop libflashsupport entirely and use a better method to enable PulseAudio support in Flash (and all ALSA applications, in fact). PulseAudio provides ALSA plugins that enable most ALSA applications to have PulseAudio support. Unfortunately, Ubuntu is one of the few distributions that did not configure PulseAudio completely and thus ALSA applications completely bypass PulseAudio, causing mixing conflicts. This issue is reported on bug #198453 and you can read the FAQ at the following link for a summary of the problem here: http://ubuntuforums.org/showthread.php?t=866965

If we remove libflashsupport and fix bug #198453, there's "good news" and "bad news" with regards to Flash:

The bad news: Flash 9 still won't work (due to Flash 9's erroneous reliance on snd_async_add_pcm_handler() which causes problems with the PulseAudio ALSA plugin). See the PulseAudio developer's comment on Flash 9 here: https://tango.0pointer.de/pipermail/pulseaudio-discuss/2008-May/001796.html

The good news: the snd_async_add_pcm_handler() issue is fixed in Flash 10 (since beta 1). Essentially, Flash 10 is 100% PulseAudio compatible when using the proper configuration of bug #198453.

In summary, the solution to this bug:
1. Upgrade to Flash 10 (at release candidate status as of 13/8)
2. Drop libflashsupport completely (it causes instability in Flash 9 and 10)
3. Fix bug #198453

This bug is a trivial fix for Intrepid (and should have been fixed a long time ago, to give PulseAudio time for testing). It is also possible to fix in Hardy, as long as the prerequisites of bug #198453 can be fulfilled whilst keeping the SRU policy for an LTS release in mind. Either way, *something needs to be done*.

TerryG (tgalati4) wrote :

Marking as incomplete until reporter posts specific examples (links) to sites that crash. Flash is a moving target in Firefox. I presume you are running the latest version of Flash?

Changed in firefox:
status: New → Incomplete
LGB [Gábor Lénárt] (lgb) wrote :

Flash plugin is downloaded and installed by flashplugin-nonfree hardy package (currently: 9.0.115.0ubuntu4), flash version - according to about:plugins - is 9.0 r115. I can't give a specific URL, all flash content can crash firefox it seems, but browsing youtube.com and watching videos can trigger the bug quite often (but not always!). I've disabled (eg: removed file /usr/lib/flashplugin-nonfree/libflashplayer.so) on the other machine; since then no crash; so I assume it's the fault of the plugin and not the browser itself.

TerryG (tgalati4) wrote :

I've only watched a few youtube videos and I've never experienced a crash, but on the forums several other folks have so I assume that it's a flash plug-in problem. If you can repeat the crash with a specific video, that would help. Also, watch your memory consumption (in a terminal: free), if you run out of swap, then that can crash firefox without warning. It could be a memory leak in the flash plug-in. I've experienced crashes with flash chat and music streaming from www.cocgospel.com so I assume that it's the flash plug-in because the crash corresponds with RAM filling up, then swap filling up, then crash.

If we can get a repeatable use case, then we can confirm the bug, otherwise we know that the non-open flash plug-in is the likely culprit, and without the source, it's tough to fix. We can work around it by watching for memory leaks, and other things that cause crashes.

LGB [Gábor Lénárt] (lgb) wrote :

Now, it's harder to trigger again but happens sometimes. I can't mention a given URL/video, it sometimes crashes on flash content, and sometimes not. There is an apport report, but I can't figure out how to attach to this bugreport, so it created another bug ticket at #198020 sorry for the action ...

Btw, I checked memory usage and it's not the case at least it didn't seem so.

LGB [Gábor Lénárt] (lgb) wrote :

Just having the same issue and apport states that there is not enough memory to report crash which is strange since there is more than 4Gbyte swap was free and also some RAM (from the 1Gbyte). Flash plugin may require abnormal huge amount of memory which is failed to allocate?

Guillaume M (diabo-bugreport) wrote :

I confirm the bug. Under gutsy, flash animations like youtube videos used to cause epiphany-browser to crash from time to time while unloading the animation. Now that I upgraded to hardy beta, this happens way more often, like on 50% of the animations. This is not reproducible for each animation.

However, I was able to find an animation which seems to trigger the bug repeatedly (or at least a bug with the same symptoms): it is the big animation at the top of http://www.makinghistory.upenn.edu/ .

(Directions:
> Let the animation play until the end and watch the browser hang
> Re-load and press the "skip intro" button to witness the same effect)

Hope it helps.

gm.

LGB [Gábor Lénárt] (lgb) wrote :

Well, it does not crash here, but quite often on youtube videos ... I've read quite large amount of posts on various forums that ubuntu hardy is very unstable if you want to use the non-free flash plugin and firefox, and some of them think (similar to me) that it can be something with pulseaudio and libflashsupport (according to some of posts even gutsy affected if pulseaudio is installed). However don't know what to do with this gossip like information here :)

Jeff Fortin Tam (kiddo) wrote :

+1 gadm. I am using epiphany-gecko with flashplugin-nonfree, and it is very easy to reproduce. Just watch random youtube videos until it crashes. I recommend searching for funny cats videos.

Epiphany+flash used to be very stable (as in: crash maybe once every 2-3 months?) in gutsy and previous releases, and now it crashes *every* day, on 25-50% of trials (trial = loading a web page containing flash content, be it youtube or something else). This is unacceptable, I had to remove flashplugin-nonfree to keep a crash-free experience for the moment being, but half of the web is crippled now (though I don't miss those ads ;).

Nothing to do with memory/swap usage. What information still needs to be provided for this bug?

Jeff Fortin Tam (kiddo) wrote :

by the way, you don't have to watch entire youtube videos. Just watching the first few seconds will determine if it's going to crash or not. So, go to youtube, and play 10 seconds of video, go to the next video, play 10 secs, etc.

It may crash on the very first one. It may crash on the 5th. On the 10th. But it will crash, sometime. I have not tried, but maybe opening multiple youtube pages in tabs at once could make it crash faster. Heck, even osnews.com makes the browser crash, and it happens so often that I disabled apport because it took me too much time to recover.

LGB [Gábor Lénárt] (lgb) wrote :

Exactly! This is why this bug is marked as incomplete because an exact description is required to reproduce the bug, but it seems it is not the nature of this bug ... And yes, crashing always occures at the starting of youtube videos but not always: sometimes crashes on the same video, sometimes not even repeating many times to trey to make firefox crashing. Firefox, epiphany are always unusable for me because of random crashes (konqueror is protected to use some kind of separated envirnoment for stuff like binary blobs, it would be a great win for firefox especially for this issue ...)

Jeff Fortin Tam (kiddo) wrote :

although this bug report seems to have been created initially before hardy, as a more generic "crashes" bug; it looks like our issue is very different in Hardy than in previous releases. Maybe we should instead be concentrating our efforts in Bug #196588 ?

LGB [Gábor Lénárt] (lgb) wrote :

Well, this bug was reported by me it was based on hardy, but I got this problem in gutsy too when I've started to play with pulseaudio. For me it seems the bug affects the daily usage of browsers since I'm using pulseaudio thus libflashsupport is needed regardless it's gutsy or hardy. For me at least, the problem is the same. I've got a crash report too with apport at bug #198020. Anyway I've just commented bug #196588 about these thoughts.

Rafael C. Brandão (rcbrandao) wrote :

I can confirm this bug as well. I'm running Ubuntu 8.04 Hardy Heron, it's fully patched and I'm getting crashes very often when I'm watching youtube videos. On the terminal, if I run firefox and this crash happens, an error message appears "Segmentation fault". I'm not sure whether this bug would apply on gutsy with pulseaudio installed. An interesting thing is that I wasn't experiencing such bug until I removed my /home directory and logged in back again.

Krister Koski (kikke) wrote :

Yes this is definitely Pulseaudio server problem, i tested it and FLash crashing stopped example with Youtube videos.
LGB [Gábor Lénárt] information is correct and i found nasty solution.

I removed all Pulseaudio packages by using Synaptic, use search and find pulse, only packages what i left there are these:
libao2
libgsm1
libpulse0
vlc
vlc-nox

so remove all other and do reboot.

But now there is still bug in PulseAudio server what need to be fixed.

Description: Ubuntu hardy (development branch)
Release: 8.04

John Vivirito (gnomefreak) wrote :

assigned package pulseaudio instead of firefox due to user comments.

Changed in pulseaudio:
status: Incomplete → Confirmed
Mike Smith (mlsmith) wrote :

I can also confirm that by deleting PulseAudio Sound Server 0.9.9-1ubuntu4 alone stopped the crashes for me.

Michael B. Trausch (mtrausch) wrote :

I decided today to rebuild a local copy of flashplugin-nonfree and remove the dependency on libflashsupport. This has fixed all of the random crashes (with useless backtraces) that I was experiencing.

It seems that there is a bug in libflashsupport that causes the crashes. I can't find any easy way to generate additional useful information, however; the mere absense of that library stops my crashes. (This is a fully up-to-date Hardy).

I recommend that the dependency on libflashsupport be dropped, in light of this. These crashes are easily preventable, and Hardy can't be released with a browser that cannot even go to YouTube.

Jeff Fortin Tam (kiddo) wrote :

could you provide your package (or give instructions to do what you did) so we can test this?

LGB [Gábor Lénárt] (lgb) wrote :

Agreed, and as I've written, it even started in gutsy when I started to play with PulseAudio. The only problem about lack of libflashsupport that you won't able to use flash sound support on hardy otherwise on "simple" sound cards, since as far as I know pulseaudio is installed by default and cheap sound cards often manages only one channel to play, so if pulseaudio is running, flash would not able to produce sound. I think libflashsupport and/or pulseaudio should be fixed instead, or Adobe should be asked to find the bug in its binary blob. But otherwise you're right even my wife say "this crap is much worse than windows, not even a single video can be viewed without crash". Ok sure she don't understand the problems and the fact that it's not a stable distribution but it shows the problem if hardy would come out in this unusable state ...

LGB [Gábor Lénárt] (lgb) wrote :

I can confirm this.

Changed in libflashsupport:
status: New → Confirmed
Michael B. Trausch (mtrausch) wrote :

A build is pending in my PPA, I am just waiting for the PPA system to actually get around to building it.

It should be done soon.

https://edge.launchpad.net/~mtrausch/+archive

Michael B. Trausch (mtrausch) wrote :

THe package should be available as soon as it moves from pending to published.

After installing it, remove libflashsupport, and restart Firefox. YouTube, et al. should work as expected unless something else is using your sound card at the time that Flash wants to try to get it.

Martin Erik Werner (arand) wrote :

Working so far without crash using your (Michael's) package, and normally I'd have crashed ten times by this much youtube browsing.

  • unnamed Edit (666 bytes, text/html; charset=ISO-8859-1)

It seems to make the situation worse in my case. Youtube videos play for
maybe 2 seconds and then they "pause", I don't know why. And also, if you
try to use rhythmbox while any youtube page is open (even if no video is
playing), rhythmbox will not play and it will hang.

As far is I knew, my sound card was capable of hardware mixing without
problems, as it was able to play tons of stuff at the same time before the
pulseaudio era (most likely with alsa?). It's an integrated SiS chip on my
motherboard. lspci tells me:

00:02.7 Multimedia audio controller: Silicon Integrated Systems [SiS] AC'97
Sound Controller (rev a0)

System: Dell Inspiron 510m
00:02.0 VGA compatible controller: Intel Corporation 82852/855GM Integrated Graphics Device (rev 02)
00:1f.5 Multimedia audio controller: Intel Corporation 82801DB/DBL/DBM (ICH4/ICH4-L/ICH4-M) AC'97 Audio Controller (rev 01)

I can confirm the same issue on my system fully up-to-date Hardy install. Navigating away from a page with flash content (usually Youtube) causes the browser to crash, reporting a segmentation fault. Attempting to view three or four videos successively on Youtube is usually enough to trigger a crash.

Installing Michael's modified package and removing libflashsupport seems to have eliminated these crashes completely; we need to investigate a way to get flash working with pulseaudio without this issue.

Same problem here, the browser usually crash when trying to display a video in a flash applet. When running from the console, it reports a segmentation fault, but nothing else. Usually when reloading firefox right afterwards using the url which just crashed, it works.

It seams flash isn't managing memory properly. After a few minutes the browser started, it is not able to play videos (memory leak in the fash plugin?).

dano (danoex) wrote :

same problem in hardy heron - firefox beta 5 - flash plugin 9,0,124,0
Always fails to open a second flash video (youtube, google video, mogulus, etc.)

Christoph Reiter (lazka) wrote :

http://www.pulseaudio.org/ticket/225

same here..
killall pulseaudio fixes it.

LGB [Gábor Lénárt] (lgb) wrote :

IMHO/AFAIK: I think this bug should be show stopper or similar at priority, since playing flash content with audio on Ubuntu as desktop operating system is not a rare usage pattern I think :) And because hardy is based on pulseaudio by default (so the flash plugin) this should be fixed before the final release of the distribution, I think. Dropping pulseaudio support from flash plugin/wrapper is not a sultion because pulseaudio is used as core audio component (if I'm not right please correct me), so it should run, and many audio hardware can't play streams from multiple sources: from flash plugin (without PA support) and from PA, so it's not the solution either. The only solution is to fix this issue or drop PA fully from the default install at least, but I think the latter is not an option.

D4nielfree (d4nielfree) wrote :

just remove the /usr/lib/libflashsupport.so solved my crashing problem
why do we need both the libflashsupport and flashplugin-nonfree anyway ??

LGB [Gábor Lénárt] (lgb) wrote :

D4nielfree: as far as I know: flashplugin-nonfree is the flash plugin itself (in fact that ubuntu package is only a downloader/installer for fetching the flash plugin from adobe through the Net and install it), while libflashsupport is for support flash to be able to play audio through PulseAudio sound server which is a core component of Ubuntu Hardy. So if you remove libflashsupport you loose the ability of working through PulseAudio. If you have a sound card which capable of playing multiple streams by hardware it's not a problem, however not every sound card is from this type, and also the basic idea of PulseAudio (and its role in Ubuntu Hardy, and also in other distributions like Fedora - as far as I know at least) is to have an audio server to be able to control all audio sources and mixing together then.

Ok, if I'm wrong in my explanation somewhere, please correct me!!

Martin Erik Werner (arand) wrote :

latest update seems to have broken Michael's package, it's not recognised by firefox at all... Grrrr!

Installing newest updated version leads to crash-fest.

Installing Michaels package makes me unable to use any flash...

Showstopper, definitely.

D4nielfree (d4nielfree) wrote :

ah.. got it..thx for the information :)
so the bug should go with the sound support, hope ppl can fix it soon

John Vivirito (gnomefreak) wrote :

This has nothing to do with Firefox rejecting the package.
If you want your bug to be looked at please file a seperate bug for each crash report and please add your crash report to the bug. this way we know what crashes when it crashes and why. Otherwise we are unablet o confirm your issue is the same as the reporters. Apport will mark as a duplicate if it sees the same faults.

Changed in firefox:
assignee: nobody → mozilla-bugs
status: New → Invalid
John Vivirito (gnomefreak) wrote :

>I decided today to rebuild a local copy of flashplugin-nonfree and remove the dependency on libflashsupport. This has >fixed all of the random crashes (with useless backtraces) that I was experiencing.

This has been done in newest flash. Flash no longer needs libflashsupport as a depends with nest version.

Vashu (mbisono) wrote :

I can confirm this bug as well. It's been happening for me since edgy maybe earlier. But got a lot more common on hardy.

Conn O Griofa (psyke83) wrote :

I have made some interesting discoveries regarding this bug.

First of all, libflashsupport appears to trigger these crashes, but it is apparently exposing a bug in flash, not pulseaudio. See this upstream ticket: http://www.pulseaudio.org/ticket/267

Secondly, I have installed Fedora 9 (rawhide i686) on my laptop (a Dell Inspiron 510m), which has the following installed:

pulseaudio-module-gconf-0.9.10-1.fc9.i386
pulseaudio-utils-0.9.10-1.fc9.i386
gstreamer-plugins-pulse-0.9.5-0.5.svn20070924.fc9.i386
pulseaudio-core-libs-0.9.10-1.fc9.i386
pulseaudio-libs-glib2-0.9.10-1.fc9.i386
pulseaudio-0.9.10-1.fc9.i386
pulseaudio-module-x11-0.9.10-1.fc9.i386
pulseaudio-esound-compat-0.9.10-1.fc9.i386
pulseaudio-libs-0.9.10-1.fc9.i386
alsa-plugins-pulseaudio-1.0.16-4.fc9.i386
libflashsupport-000-0.5.svn20070904.i386
flash-plugin-9.0.124.0-release.i386
nspluginwrapper-0.9.91.5-26.fc9.i386

What I noticed is that Firefox never crashes on flash contents in Fedora 9 with the packages listed above, and pulse output works perfectly. If I remove nspluginwrapper, however, Firefox crashes on flash contents, just as in Hardy. I am guessing that the npviewer.bin process is isolated and prevents firefox from crashing.

I find it interesting that Fedora ships with nspluginwrapper for the x86 architecture, since it seems redundant, but it appears to solve the problem with flash. I will try to recompile nspluginwrapper on Hardy for the i386 architecture and see if it helps with this problem.

Conn O Griofa (psyke83) wrote :

I have compiled and installed nspluginwrapper (from the original source, so it's a manual install).

I now experience the following behaviour:
Browsing Youtube works correctly as usual, but at some times the flash box turns grey and a message dialog pops up saying this: "This problem report does not apply to a packaged program. (/usr/lib/nspluginwrapper/i386/linux/npviewer.bin)". Firefox does not crash, and if I confirm the dialog and reload the page, flash content will load normally.

I noticed in Fedora 9 that the flash box would turn grey, but there was no error dialog, so perhaps it's related to Ubuntu's extra apport or bugreporting hooks.

It appears that nspluginwrapper has potential to protect flash from taking down the entire Firefox process, so I think we should consider creating an i386 flavour of the wrapper too. This makes sense since we have no control over the non-free flash plugin's development, and it appears to protect Firefox from completely crashing.

Conn O Griofa (psyke83) wrote :

I hacked the amd64 source and built an i386 package of nspluginwrapper. It seems to work identically to Fedora 9; when flash crashes, the flash box turns grey but Firefox does not crash. There's no error dialog either (as mentioned in my last post).

If you test this package, remember that you have to reinstall flashplugin-nonfree afterwards, i.e.:

sudo dpkg -i /path/to/nspluginwrapper_0.9.91.5-2ubuntu2_i386.deb
sudo apt-get remove --purge flashplugin-nonfree
sudo apt-get install flashplugin-nonfree

ski (skibrianski) wrote :

I heartily agree with Conn's observations about nspluginwrapper (or something like it) having an x86 port. The thing I noticed immediately when I switched to nspluginwrapper (from a chroot jail where I ran x86 firefox) was that when I was watching a flash video which takes >90% cpu in one tab (e.g. msnbc), I could still navigate on the other tabs freely, because of the seperate process (it's a dual core machine).

So there are performance, as well as crash-protection, reasons to move in the "seperate process" direction. It's not really germane to this bug, but I wanted to put my 2 cents in, because I think it's a great idea.

chastell (chastell) wrote :

I can confirm that Conn’s solution from https://bugs.launchpad.net/ubuntu/+source/pulseaudio/+bug/192888/comments/39 seems to have fixed this issue for me (and it was really annoying, as basically every second flash movie crashed the whole Firefox). I’m on current Hardy.

Alexander Sack (asac) wrote :

as a compromise we should remove libflashsupport from depends: in flashplugin-nonfree and make a suggests out of it.

Changed in flashplugin-nonfree:
importance: Undecided → High
status: New → Triaged
Alexander Sack (asac) wrote :

pulseaudio does not contribute to this crash afaict.

Changed in pulseaudio:
status: Confirmed → Invalid
Alexander Sack (asac) wrote :

libflashsupport is most likely the right package to fix this for real. However, the issue is not yet understood and we probably need more info about what flashplugin-nonfree does to fix this.

Changed in libflashsupport:
importance: Undecided → High
Alexander Sack (asac) wrote :

previous patch is the best we can probably do for hardy.

Changed in flashplugin-nonfree:
status: Triaged → Fix Committed
-Zeus- (matthew-momjian) wrote :

can not confirm this. Running Hardy 8.04b with all latest updates (main, universe, restricted, and multiverse) and the following sources: hardy-security, hardy-updates, hardy-proposed, and hardy-backports. I am also running firefox-3.0b5

Alexander Sack (asac) wrote :

Zeus, what can't you confirm?

description: updated
description: updated
Conn O Griofa (psyke83) wrote :

Alexander,

The pulseaudio developers have stated that the problem is not because of libflashsupport, but flash itself.

http://www.pulseaudio.org/ticket/225
http://www.pulseaudio.org/ticket/267

Alexander Sack (asac) wrote :

maybe flash is wrong, but you cannot tell because its not free. I don't see anything that clearly indicates that this is a flash bug. Its libflashsupport that introduces a new mutex if i read ticket 267 correctly.

Matthew Tighe (tighem) wrote :

I tried turning on pulse again today and Flash played just fine for me. Previously with flash running flash content would stop at 1-2 seconds in if pulse was running.

The Outfield (outfield) wrote :

Conn's updated nspluginwrapper works! Perfect for me - no more crashes after having consistently annoying crashes about every third youtube video I watched.

Thank you!

I can confirm this on a 32-bit install. At my house we call this the "Incredible Disappearing Firefox" bug and it's the oldest bug in Ubuntu for me, it's been happening on every Ubuntu release, and no other distribution. (For me). Seeing this bug fixed would make me happy, but I'm not getting my hopes up high.

cameo73 (jeroen-brattinga) wrote :

I've seen this bug on Gutsy (using ALSA), but it's now extremely prevalent in (the latest beta version of) Hardy. When I enable FLASH_AUDIODEBUG, I get the following output:
--- START OUTPUT ---
** Message: GetValue variable 1 (1)
** Message: GetValue variable 2 (2)
** Message: GetValue variable 1 (1)
** Message: GetValue variable 2 (2)
** Message: GetValue variable 1 (1)
** Message: GetValue variable 2 (2)
** Message: GetValue variable 1 (1)
** Message: GetValue variable 2 (2)
** Message: GetValue variable 1 (1)
** Message: GetValue variable 2 (2)
** Message: GetValue variable 1 (1)
** Message: GetValue variable 2 (2)
**
** Gtk:ERROR:(/build/buildd/gtk+2.0-2.12.9/gtk/gtkplug.c:182):gtk_plug_set_is_child: assertion failed: (!GTK_WIDGET (plug)->parent)
Aborted
--- END OUTPUT ---

This happened immediately after opening any movie on YouTube. Nowadays I seem to have a 50/50 chance of Firefox crashing if I move to or from a page containing a Flash movie.

cameo73 (jeroen-brattinga) wrote :

I just noticed the Conn's proposed fix/workaround.

After testing it I can say it completely eliminates the Firefox crashing problem! I can see Flash movies initially being drawn as a grey box (for a second) on entering or leaving a page, but Firefox stays rock solid!

Thanks Conn, you've just made my day!

Alexander Sack (asac) wrote :

uploaded the debdiff from comment 44. for hardy we should definitly look into using nspluginwrapper on all archs. agreed.

Martin Pitt (pitti) wrote :

Keeping in unapproved queue until this gets an ack from motu-release.

sethloco (sethloco78-linux) wrote :

I can confirm that Conn's fix/workaround has fixed the Firefox/Flash crashing problem for me. Thanks a lot.

Running Hardy Beta / Firefox Beta 5.
Flash was continuing to crash firefox by either locking up the browser or exiting. I could play 2, maybe 3, flash videos before this symptom would take effect.

After applying Conn's fix/workaround, this issue no longer occurs for me.

Scott Kitterman (kitterman) wrote :

Ack for motu-release.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package flashplugin-nonfree - 9.0.124.0ubuntu2

---------------
flashplugin-nonfree (9.0.124.0ubuntu2) hardy; urgency=low

  * fix "frequent crashes with flash on youtube"; we fix this by
    demoting libflashsupport from depends: to suggests: (LP: #192888)
    This has positive as well as negative consequences:
     (+) increased stability for firefox and nspluginwrapper
     (-) pulseaudio users reported that this breaks sound if flash
         while other applications are running that use the sound
         device for output.
    Users that installed libflashsupport during hardy cycle should
    uninstall it to increase stability.
    - update debian/control

 -- Alexander Sack <email address hidden> Wed, 16 Apr 2008 00:39:41 +0200

Changed in flashplugin-nonfree:
status: Fix Committed → Fix Released
Alessandro Grechi (alexit) wrote :

Good news ! ;)
So, we'll need to unistall libflashsupport, right?

And nspluginwrapper, will'be necessary or optional?

cameo73 (jeroen-brattinga) wrote :

Demoting libflashsupport from depends to supports is NOT a fix! Sure it increases stability, but it removes the functionality the library was supposed to add...!

It reminds me of one of those doctor-jokes:
- Patient: "If I press here, it hurts."
- Doctor: "Well, then just stop pressing there!"

At least with the Conn-"fix" stability is increased AND libflashsupport functionality is kept. IMO this is a far better alternative; at least until Adobe fixes this one for real.

I'm EXTREMELY dissapointed in the "fix". It's not a fix, it's a work around that makes Flash not have sound or software mixing. This dependency needs to come back, because we're just trading one problem for another!!!

Using nspluginwrapper on all archs would be the easiest and best solution, so please reintroduce that dependency (before users start complaining about the new problem that it will cause) and make nspluginwrapper used on 32 and 64-bit.

I'll go even further to suggest that nspluginwrapper should be coded so that if it crashes, it reloads itself. That way, no one will ever notice that Flash has crashed.

LGB [Gábor Lénárt] (lgb) wrote :

Hmm, please correct me if I am wrong, but I also think it's a big problem: AFAIK many sound cards (or at least their drivers) can only play one pcm channel from hardware, and since pulseaudio is installed by default on hardy which uses the sound device it sould mean that "fix" makes flash doesn't have sound which is quite big problem for an average desktop user want to see embedded videos on web pages using flash players, like youtube website. Also the main concept of hardy to have pulseaudio as the core componenet of all of the audio in the system which rule is violated by this "fix".

Conn O Griofa (psyke83) wrote :

I wouldn't get so worried yet; Unless I'm mistaken, I think this bug was automatically marked as Fix Released due to the previous commit by Alexander before he decided to include nspluginwrapper.

Alexander, do you need any help reworking the nspluginwrapper amd64 package? I can give it a try if you're short on manpower, although I tend to manually edit files, I've never used packaging tools.

Ewan Dunbar (ewan-dunbar) wrote :

this latest fix doesn't work for me - the flash plugin no longer loads at all.

cameo73 (jeroen-brattinga) wrote :

The update I saw yesterday in update-manager (9.0.124.ubuntu2) really increased stability for me.

Without the nspluginwrapper, opening the first 10 YouTube movies (on the front page) in separate tabs seems to work 9 out of 10 times I try it.
When it fails, it will take down the browser with it.

If I repeat the test with nspluginwrapper, the browser never crashes.
Worst case the flashplugin would crash and leave a grey box for every open Flash movie.

For the record: I'm testing with a NVIDIA 8800GT (173.08 beta driver) video card, Bose Companion 5 USB Audio (Hardy Heron driver) and an Intel Core Duo E8450. Compiz is enabled.

Jürgen Kreileder (jk) wrote :

nspluginwrapper fixes the firefox crashes but it's only a suboptimal work-around. The flash plugin still crashes a lot, it just doesn't take firefox with it anymore!

The real problem that has to be fixed are the flushplugin crashes. The number of those increased dramatically about 2 weeks ago, for me they are neither caused by pulseaudio nor by libflashsupport. I'll try to debug it on the weekend if i get some free time.

(The addition of nspluginwrapper is still welcome though because of the introduced asynchronity.)

Juergen: As I commented in one of the duplicates, pulseaudio or libflashsupport are not the issue for me either. But disabling desktop effects stopped all the crashes for me - though the problem started occuring at the exact same time as for everyone else, a few weeks back. Before that it has worked fine for a vey long time.

LGB [Gábor Lénárt] (lgb) wrote :

Juergen: yes, the real fix should be inside the Adobe's blob [according to bug tricket on pulseaudio it's some kind of race condition inside plugin itself where pulseaudio only triggers the problem and not cause) :) However using nspluginwrapper has more advantages as well: if every plugins would use separated environments (eg security policies can be applied more easly to them), it can be good for security and also helps load multiple cores/CPUs because running as a separate process. It also helps firefox not to be so slow to react when a plugin inside the firefox process is too resource hungry. So, even this fix does not cure the real problem, it's the best besides the fix of the plugin itself (only adobe can do it), and also it can be good for crash protection in future similar bugs. And has got other advantages too, I've described (security, better usage of multiple CPUs/cores). So using nspluginwrapper is a good thing or at least some kind of similar separation should be developed for firefox to allow to separate plugins from the core borwser itself better. Sure, this was IMHO and AFAIK :)

starNIX (ben-pregont) wrote :

FYI -

I have desktop effects disabled and I still experience these crashes.

cameo73 (jeroen-brattinga) wrote :

I can confirm that disabling desktop effects has no effect on the crashes. I did find one movie that crashes consistently for me:

--> http://www.shockwave.com/gamelanding/doeo.jsp
- Wait for the commercial, then select your language (English)
- With Compiz, it immediately crashes; with Metacity, it takes a couple of seconds longer (right after the Doeo animation)
- This is with libflashsupport and nspluginwrapper (so the crashes are confined to the Flash plugin)

Output when using Metacity (starting Firefox -> opening page -> movie crash):
--- START OUTPUT ---
(firefox:3972): Gtk-CRITICAL **: gtk_widget_get_display: assertion `GTK_IS_WIDGET (widget)' failed
(firefox:3972): Gtk-CRITICAL **: gtk_widget_get_display: assertion `GTK_IS_WIDGET (widget)' failed
(firefox:3972): Gtk-CRITICAL **: gtk_widget_get_display: assertion `GTK_IS_WIDGET (widget)' failed
(npviewer.bin:4446): Gtk-CRITICAL **: gtk_style_detach: assertion `style->attach_count > 0' failed
(npviewer.bin:4446): Gtk-CRITICAL **: gtk_widget_hide: assertion `GTK_IS_WIDGET (widget)' failed
(npviewer.bin:4446): Gtk-CRITICAL **: gtk_widget_destroy: assertion `GTK_IS_WIDGET (widget)' failed
(npviewer.bin:4446): Gtk-CRITICAL **: gtk_widget_hide: assertion `GTK_IS_WIDGET (widget)' failed
(npviewer.bin:4446): Gtk-CRITICAL **: gtk_widget_destroy: assertion `GTK_IS_WIDGET (widget)' failed
(npviewer.bin:4446): Gtk-CRITICAL **: gtk_widget_destroy: assertion `GTK_IS_WIDGET (widget)' failed
(npviewer.bin:4552): Gtk-CRITICAL **: gtk_style_detach: assertion `style->attach_count > 0' failed
(npviewer.bin:4552): Gtk-CRITICAL **: gtk_widget_hide: assertion `GTK_IS_WIDGET (widget)' failed
(npviewer.bin:4552): Gtk-CRITICAL **: gtk_widget_destroy: assertion `GTK_IS_WIDGET (widget)' failed
(npviewer.bin:4552): Gtk-CRITICAL **: gtk_widget_hide: assertion `GTK_IS_WIDGET (widget)' failed
(npviewer.bin:4552): Gtk-CRITICAL **: gtk_widget_destroy: assertion `GTK_IS_WIDGET (widget)' failed
(npviewer.bin:4552): Gtk-CRITICAL **: gtk_widget_destroy: assertion `GTK_IS_WIDGET (widget)' failed
(npviewer.bin:4716): GLib-GObject-WARNING **: IA__g_object_newv: property `has-alpha' of object class `GdkPixbuf' is not writable
(npviewer.bin:4716): GLib-GObject-WARNING **: IA__g_object_newv: property `has-alpha' of object class `GdkPixbuf' is not writable
--- END OUTPUT ---

Output when using Compiz:
--- START OUTPUT ---
(npviewer.bin:9136): Gtk-CRITICAL **: gtk_style_detach: assertion `style->attach_count > 0' failed
(npviewer.bin:9136): Gtk-CRITICAL **: gtk_widget_hide: assertion `GTK_IS_WIDGET (widget)' failed
(npviewer.bin:9136): Gtk-CRITICAL **: gtk_widget_destroy: assertion `GTK_IS_WIDGET (widget)' failed
(npviewer.bin:9136): Gtk-CRITICAL **: gtk_widget_hide: assertion `GTK_IS_WIDGET (widget)' failed
(npviewer.bin:9136): Gtk-CRITICAL **: gtk_widget_destroy: assertion `GTK_IS_WIDGET (widget)' failed
(npviewer.bin:9136): Gtk-CRITICAL **: gtk_widget_destroy: assertion `GTK_IS_WIDGET (widget)' failed
--- END OUTPUT ---

Jürgen Kreileder (jk) wrote :

Kristoffer, compiz isn't causing the problem for me. It's disabled. It also doesn't make a difference whether I enable hardware acceleration in the flashplugin or not.

LGB, as said, pulseaudio isn't the problem in my case. I don't use at all. I do audio multiplexing via ALSA's dmix instead. (I like the positive sides of nspluginwrapper too, without it flash slide shows which load a lot of pictures can hang firefox for minutes).

The flashplugin might have its bugs which Adobe should fix but the recent increase in crashes definitely was caused by a change in Hardy.

Scott Kitterman (kitterman) wrote :

Unsubscribing motu-release as there is no current action for the team.

Daniel T Chen (crimsun) wrote :

Given that we're less than one week from hardy's release, /if/ we retain this libflashsupport demotion in the flashplugin-nonfree source package, we should /also/ back out the runtime hal-aware functionality in the pulseaudio source package. Please see http://pastebin.com/m69f447bb (link will expire in one month) for a recommended patch for pulseaudio that will "unbreak" the current audio situation.

Alexander asked for rationale in #ubuntu-devel yesterday, so I'll explain three {dist-,}upgrade scenarios that should be considered given a /default/ configuration.

1) In dapper, the flashplugin-nonfree source pulls down upstream version 7.0.63. This version of Flash does not use ALSA. It uses OSS, hence the myriad hacks in the source package to allow aoss to wrap the web browser. (9.0.48 is available in dapper-backports, but that's not the issue we're discussing here.) There is no polypaudio/pulseaudio support, nor is there any libflashsupport package available.

2) In gutsy, the flashplugin-nonfree source pulls down upstream version 9.0.48 (and 9.0.124 in gutsy-updates). This version of Flash /does/ use ALSA (and falls back to OSS). There is no pulseaudio support, nor is there any libflashsupport package available.

3) In hardy, the flashplugin-nonfree source pulls down upstream version 9.0.124. Like the version(s) in gutsy (and gutsy-updates), this version of Flash supports ALSA but does not support pulseaudio. However, hardy does make available libflashsupport in universe, but currently this package is only Suggested by flashplugin-nonfree, and most users will not have it installed via upgrade-manager or apt-get on a dist-upgrade. (A corner case is current hardy testers who had it pulled in via the previous Depends.)

Given the above three cases, we should now discuss users who have configured non-GStreamer applications to use ALSA. If such a user dist-upgrades to hardy, audio currently will appear to "break". Because pulseaudio is configured to exclusively grab the raw audio hardware, Flash (and all other ALSA-configured apps) will block if s/he attempts to play audio after pulseaudio has been invoked.

So where does the above patch come in? Applying it makes pulseaudio use the 'default' ALSA virtual device, which is dmixed and dsnooped for nearly all audio cards. This change means that audible sound is restored to the current hardy Flash config (as well as other non-GSt apps). Furthermore, it means that any users who have created an asoundrc will have their asoundrcs honoured by pulseaudio. This is semantically intentional, because we should not break users' existing audio configurations.

To summarise, currently the libflashsupport demotion is incomplete. It needs the above accompanying pulseaudio config change to unbreak current audio /and/ dist-upgrades. While we would have to give up the runtime hal-aware functionality, we would not introduce regressions from dapper(, edgy, feisty), gutsy, and current hardy.

Conn O Griofa (psyke83) wrote :

Hi Daniel,

I'm glad you have a solution, but won't this create even higher latency due to dmix? Many sound cards do not support hardware mixing, or support a limited range of rates, so dmix will be processor intensive. For example, my STAC9750,51 only supports 48000Hz natively (and dmix/pulseaudio downsamples to 44100 by default, I think).

ski (skibrianski) wrote :

Just to add (another) 2 of my cents...

Latest upgrades give me a working ffox/flash solution again, yay! I can unpin firefox and xulrunner! Thanks all!

As for the patch from Daniel, I hear Conn's concerns about latency and cpu usage, but I think it's important to get correct operation before optimization. But Hardy needs a flash/ffox solution that works on all amd64 machines, and even tho Daniel's solution seems suboptimal, if I understand it correctly it will make flash with audio work virtually everywhere... Figuring out out how to clean up and optimize can come later, but correct operation cannot, IMO.

If we can get decent testing on Daniels patch in the next 5 days in another question, however... I'm guessing from the number of duplicates of this bug and therefore people subscribed to this bug that we can.

Conn O Griofa (psyke83) wrote :

Daniel,

PulseAudio does not work with the modifications in consider_2.diff. Here's the output:

conn@inspiron:~$ pulseaudio
W: pid.c: Stale PID file, overwriting.
W: alsa-util.c: Device default doesn't support 44100 Hz, changed to 48000 Hz.
W: alsa-util.c: Device default doesn't support 44100 Hz, changed to 48000 Hz.
E: source.c: Assertion 'PA_SOURCE_OPENED(s->thread_info.state)' failed at pulsecore/source.c:278, function pa_source_post(). Aborting.
Aborted

This is on a fresh install of the Hardy RC with no changes to PulseAudio and no custom .asoundrc file.

Daniel T Chen (crimsun) wrote :

Conn, please use `pulseaudio -vv'.

Conn O Griofa (psyke83) wrote :

Using this new default.pa, it seems that pulseaudio fails to initialize 4/5 times, but it does work for every 1/5 or so attempts. It seems to be a random phenomenon, and I did not have any applications running that would lock the sound card for access.

I simply ran "pulseaudio -vv" from the terminal without administrator privileges, and kept retrying until pulseaudio initialized properly.

Conn O Griofa (psyke83) wrote :

Using this new default.pa, it seems that pulseaudio fails to initialize 4/5 times, but it does work for every 1/5 or so attempts. It seems to be a random phenomenon, and I did not have any applications running that would lock the sound card for access.

I simply ran "pulseaudio -vv" from the terminal without administrator privileges, and kept retrying until pulseaudio initialized properly.

Conn O Griofa (psyke83) wrote :

My apologies for the double post, launchpad is acting erratically tonight. Attaching the log of a successful initialization of pulseaudio.

Conn wrote:
> My apologies for the double post, launchpad is acting erratically
> tonight. Attaching the log of a successful initialization of pulseaudi
>
> Tis is my problem! I cannot install Virus program.........
>
> ** Attachment added: "PulseAudio log (successfully initializes)"
> http://launchpadlibrarian.net/13583939/pulseaudio2.log
> : Failed to fetch cdrom:[Ubuntu-Server 8.04 _Hardy Heron_ - Release Candidate i386 (20080416)]/pool/main/p/postgresql-8.3/libpq5_8.3.1-1_i386.deb
>

Daniel T Chen (crimsun) wrote :

Some comments on the referenced commit:

1) It addresses regressions from previous, supported Ubuntu releases identified above. Non-Free Flash will work, using dmix, with the first audio device. PulseAudio is configured to use dmix on this first audio device, too.
2) Migrating Flash streams using PulseAudio will require a user-invoked, subsequent installs of libflashsupport and pacmd/pavucontrol from the universe component.
3) We retain the use of hal-aware hot(un)plug for additional devices.

More testers are needed; please comment on your experiences here.

Alexander Sack (asac) wrote :

this config works great for me. the previous one made parallel streams stutter, but this works good.

Fabien Tassin (fta) wrote :

Works great for me too.
I can play sounds in mplayer, rhythmbox, firefox 3 + flash-nonfree (without libflashsupport) and Nexuiz, all at the same time.
No ff3 crash so far.

Michael Onnen (michael-onnen) wrote :

same here, mplayer, rhythmbox, firefox 3 + flash-nonfree (without libflashsupport) now all play at the same time.
no ff3 crashes either.
only one thing: i now get this in syslog:

Apr 20 21:32:05 xp1200 pulseaudio[7081]: alsa-util.c: Error opening PCM device hw:0: Device or resource busy
Apr 20 21:32:05 xp1200 pulseaudio[7081]: module.c: Failed to load module "module-alsa-sink" (argument: "device_id=0 sink_name=alsa_output.pci_10de_59_sound_card_0_alsa_playback_0"): initialization failed.
Apr 20 21:32:05 xp1200 pulseaudio[7081]: alsa-util.c: Error opening PCM device hw:0: Device or resource busy
Apr 20 21:32:05 xp1200 pulseaudio[7081]: module.c: Failed to load module "module-alsa-source" (argument: "device_id=0 source_name=alsa_input.pci_10de_59_sound_card_0_alsa_capture_0"): initialization failed.

but like i said, everything appears to work

Daniel T Chen (crimsun) wrote :

Michael, the debug spew is correct but non-fatal. Those messages are a side effect of loading alsa-s{ink,ource} before hal-detect. The reason you get audible audio out of mplayer+rhythmbox+ff3.0b5+Flash is due to loading alsa-sink first.

Michael Onnen (michael-onnen) wrote :

Thanks Daniel, but I now have a new problem: there is very audible stutter when switching workplaces in compiz. CPU- or I/O-load is not a problem, just switching workplaces makes it stutter (most of the time).

cameo73 (jeroen-brattinga) wrote :

I tried the latest patch, but had one problem: the dsnoop device wasn't recognized. This caused a fatal error (and PulseAudio terminated).
The relevant output was:
--- START OUTPUT ---
I: module-alsa-sink.c: Starting playback.
I: module.c: Loaded "module-alsa-sink" (index: #0; argument: "device=dmix").
ALSA lib pcm_dsnoop.c:565:(snd_pcm_dsnoop_open) unable to open slave
E: alsa-util.c: Error opening PCM device dsnoop: No such file or directory
E: module.c: Failed to load module "module-alsa-source" (argument: "device=dsnoop"): initialization failed.
E: main.c: Module load failed.
E: main.c: Failed to initialize daemon.
I: module.c: Unloading "module-alsa-sink" (index: #0).
I: sink.c: Freeing sink 0 "alsa_output.dmix"
I: source.c: Freeing source 0 "alsa_output.dmix.monitor"
I: module.c: Unloaded "module-alsa-sink" (index: #0).
I: main.c: Daemon terminated.
--- END OUTPUT ---

I got it working by commenting out the "load-module module-alsa-source device=dsnoop" line. I have no idea if my audio setup (Bose Companion 5 USB Audio) is capable of audio input (was never interested in it). With the commented line, PulseAudio loads succesfully and will play FF3, Exaile and Totem simultaneously.

-Zeus- (matthew-momjian) wrote :

when I said "I cannot confirm" I mean that I don't get the problem

Daniel T Chen (crimsun) wrote :

cameo73, what's the output from: `cat /proc/asound/devices'?

Daniel T Chen (crimsun) wrote :

Michael, does using -server alleviate the stuttering?

ski (skibrianski) wrote :

I was affected by this bug, but everything is working fine for me now.

cameo73 (jeroen-brattinga) wrote :

Daniel, here's the requested output:
--- START OUTPUT ---
  1: : sequencer
 32: [ 1] : control
 33: : timer
 48: [ 1- 0]: digital audio playback
--- END OUTPUT ---
Btw, the .nofail section works as expected.

Conn O Griofa (psyke83) wrote :

Daniel,

Using revision 23 allows pulseaudio and ALSA applications to successfully share the sound card. However, there are issues.

The first issue is that sound is stable when playing from one source, but more than one source causes sound to quite easily stutter. I will try to force pulseaudio to use 48000Hz (which is my sound card codec's only supported native rate) to see if it helps, but I never had such stuttering issues with dmix (i.e. regular ALSA application sharing sound).

The second issue is that pulseaudio is preventing my soundcard from entering a powersaving state on idle (via snd-ac97-codec power_save=1). When the codec gets switched off (and back on) my card usually makes an almost inaudible "pop" sound, but this never happens. Two seconds after killing the pulseaudio process lets it kick in, however. I assume this is because you do not use module-suspend-on-idle anymore. Since I am on a laptop, this is an important issue for me.

I don't mean to be overly pessimistic, but I don't see the value of pulseaudio when it introduces these regressions. It's a shame that the "glitch-free"* code didn't make it in time for Hardy.

I still get warnings when invoking pulseaudio, I'll post the verbose log again in case it's useful.

*See: http://0pointer.de/blog/projects/pulse-glitch-free.html

Conn O Griofa (psyke83) wrote :

Given the warnings about real-time and high-priority scheduling, I added my user to the pulse, pulse-access and pulse-rt groups, then logged back in. This seems to have solved the stuttering issue with multiple sound sources.

I have noticed another very serious issue, however. When I adjust the sound via my laptop hotkeys, I get a visual indicator of the sound increasing or decreasing, etc., but no changes are applied to any of the mixers. Using the volume control applet works normally, though. I have never had this issue before, so I assume it's pulseaudio related. What can I do to troubleshoot this issue?

Alexander Sack (asac) wrote :

opening pulseaudio task as it appears from recent discussion that pulseaudio is probably the right place to land a workaround.

This fix certainly won't make the 8.04 train as there is still too much uncertainty. milestoning for 8.04.1

Changed in pulseaudio:
importance: Undecided → High
milestone: none → ubuntu-8.04.1
status: Invalid → Confirmed
Daniel T Chen (crimsun) wrote :

Conn,

1) Please attempt to reproduce the stuttering symptoms using the -server kernel (bug 188226, also comment 96 above). Note also in your attached logfile: "W: alsa-util.c: Device dmix doesn't support 44100 Hz, changed to 48000 Hz" and 'I: sink.c: Created sink 0 "alsa_output.dmix" with sample spec "s16le 2ch 48000Hz"'.

2) The rationale for not loading module-suspend-on-idle by default is the race condition noted in comment 86 above. (Moving that load statement to the end of the conffile does not give a deterministic solution, either). You can, however, use `pactl load-module module-suspend-on-idle'.

Finally, the warnings are expected and non-fatal (comment 91 above).

Daniel T Chen (crimsun) wrote :

Conn,

The effect of volume keys can be configured using System> Preferences> Sound> Devices> Default mixer tracks> Device, then selecting whichever combination seems suitable.

Changed in pulseaudio:
status: Confirmed → In Progress
Conn O Griofa (psyke83) wrote :

Daniel,

Thanks, I must have changed the default mixer setting by accident, the laptop keys work now.

I have already been following bug #188226 and tried the -server kernel, but it does not boot on my laptop. I forget the exact output, but it mentioned something about a missing CPU feature. Sorry. I will try it on my desktop later today.

As for the sample spec, the warning output leads me to believe that pulseaudio will select "s16le 2ch 48000Hz", but paman still reports "s16le 2ch 44100Hz". I believe that I would need to manually set the rate in daemon.conf (although I have not yet done so). As I said, adding my user to the pulse-* groups has solved the stuttering.

Thanks for confirming my suspicion re: suspend-on-idle; if your fixes make it into Hardy, it would be very nice to figure out a way to get this functionality back without introducing race conditions.

Conn O Griofa (psyke83) wrote :

I managed to compare the -server and -generic kernel on my desktop, details follow.

System: Dell Dimension 1100 (Celeron(R) CPU 2.80GHz, Analog Devices AD1980)
Configuration: Default Hardy install, using "nv" video driver, rev.23 patched default.pa. User is *not* part of pulse, pulse-access, pulse-rt groups, and no other customization to audio (i.e. .asoundrc) or pulseaudio.
Test file: .avi movie (video codec: 624 x 352 XVID MPEG-4 24fps; audio codec: mp3 48Khz 131kbps)

Procedure:
1. Open one instance of test file in Totem(-gstreamer) and two in VLC - total of three open movies.
2. Repeatedly perform multitasking operations (switch between movie windows, switch workspaces).

Results:
Both kernels: audio mixing works correctly, audio can be heard from all three movie players simultaneously.
-generic kernel: noticeable audio stuttering during multitasking operations, otherwise audio seems ok.
-server kernel: no audio stuttering during multitasking operations or inactivity.

Conn O Griofa (psyke83) wrote :

I added my user to the pulse groups and ran the same test as above. It seems the -generic kernel works a little better, but I can still hear some stuttering. The -server kernel still hasn't demonstrated a single stutter under the same testing conditions.

Confirm. Raindom crashes on Hardy.

I have three computers running Hardy. My Acer laptop, my main desktop, and my wife's Intel desktop.

Each of them are 32-bit installs except for my main desktop which is a 64-bit install. My main desktop and laptop never have the "incredible disappearing Firefox" bug anymore, but my wife's desktop does.

A couple of days ago I decided to reinstall Hardy on my wife's computer, this time using 64-bit instead of 32-bit. I was thinking that perhaps since the 64-bit version uses nspluginwrapper, it may solve her Firefox disappearing issues, but it didn't. It still randomly closes all of a sudden.

I just don't get it, my laptop and desktop are fine, but my wife's computer is still having the disappearing problem. What could be causing it? There are hundreds of replies here in this report so I'm confused as to what is "the fix" that was released, and I'm even more confused as to out of these three PC's hers is the only one still doing it.

Any ideas on what I should try?

Daniel T Chen (crimsun) wrote :

Jeremy,

To summarise: the fix that was applied (by Alexander) is to remove libflashsupport as a dependency of flashplugin-nonfree, meaning that new installs of (or dist-upgrades to) hardy will not have the libflashsupport package installed automatically. It appears that the libflashsupport package only exacerbates Flash's instability.

What I've proposed, with numerous responses and ensuing revisions, is the "other" piece to the puzzle of having Flash work audibly with PulseAudio given Alexander's change.

Thanks Daniel,

Is there anything I should try on my Wife's computer? I am having a hard
time understanding why it's fine on my desktop and laptop but not her
computer. I even reinstalled Ubuntu on hers and tried 64-bit.

Daniel T Chen wrote:
> Jeremy,
>
> To summarise: the fix that was applied (by Alexander) is to remove
> libflashsupport as a dependency of flashplugin-nonfree, meaning that new
> installs of (or dist-upgrades to) hardy will not have the
> libflashsupport package installed automatically. It appears that the
> libflashsupport package only exacerbates Flash's instability.
>
> What I've proposed, with numerous responses and ensuing revisions, is
> the "other" piece to the puzzle of having Flash work audibly with
> PulseAudio given Alexander's change.
>
>

Daniel, I can confirm Conn's #106 findings on all points.
rev. 23 with -server = no stuttering

> Daniel T Chen wrote:

>> the fix that was applied (by Alexander) is to remove libflashsupport
>> as a dependency of flashplugin-nonfree, meaning that new installs of
>> (or dist-upgrades to) hardy will not have the libflashsupport package
>> installed automatically.

Still, upgrades from Hardy alphas and betas
(and, perhaps, RC?) have the package installed.

Jeremy LaCroix:

> Is there anything I should try on my Wife's computer?

First, make sure libflashsupport is *not* installed.

-- Shot
--
It wasn't the Exxon Valdez captain's driving that caused
the Alaskan oil spill. It was yours. -- Greenpeace ad

Conn O Griofa (psyke83) wrote :

Alexander,

I agree we need to follow the first option mentioned in #198452, i.e. the "PerfectSetup" route, but I hope you don't forget the required asound.conf entries, but also new dependencies such as libsdl1.2debian-pulseaudio and libao-pulse to be given priority over the -alsa packages.

As for the nonfree flash (which you can count on ~99% of the Hardy user base installing that do not understand or care about the philosophical concerns against closed-source solutions, and given the current state of gnash and swfdec), we are effectively powerless to help compatibility with PulseAudio until Adobe provide a fix themselves. Remember, libflashsupport is actually Adobe's interface, and the PulseAudio developers can only provide an implementation of it, not fix the implementation itself.

If you decide on this route, I think we should look back towards the inclusion of nspluginwrapper on 32bit architectures or else we will have a lot of unhappy Firefox users. Since we are on such a tight schedule and I would consider this a bug fix rather than feature, maybe it should be considered for hardy-updates at the very least.

ski (skibrianski) wrote :

For what it's worth, I think that it should be in hardy-updates and 8.04.1, both 32 and 64 bit.

  • unnamed Edit (2.2 KiB, text/html; charset=ISO-8859-1)

I wouldn't consider using nspluginwrapper on 32-bit a fix just yet, as even
on a 64-bit install with nspluginwrapper, Flash crashes still brings down
the entire Firefox instance. I think the only sensible solution is to
include Pulse Audio, but don't turn it on by default, let the user turn on
Pulse Audio if they want it. Pulse Audio is way too unstable and incomplete
to even be considered for an LTS release.

On Tue, Apr 22, 2008 at 4:40 PM, Conn <email address hidden> wrote:

> Alexander,
>
> I agree we need to follow the first option mentioned in #198452, i.e.
> the "PerfectSetup" route, but I hope you don't forget the required
> asound.conf entries, but also new dependencies such as libsdl1.2debian-
> pulseaudio and libao-pulse to be given priority over the -alsa packages.
>
> As for the nonfree flash (which you can count on ~99% of the Hardy user
> base installing that do not understand or care about the philosophical
> concerns against closed-source solutions, and given the current state of
> gnash and swfdec), we are effectively powerless to help compatibility
> with PulseAudio until Adobe provide a fix themselves. Remember,
> libflashsupport is actually Adobe's interface, and the PulseAudio
> developers can only provide an implementation of it, not fix the
> implementation itself.
>
> If you decide on this route, I think we should look back towards the
> inclusion of nspluginwrapper on 32bit architectures or else we will have
> a lot of unhappy Firefox users. Since we are on such a tight schedule
> and I would consider this a bug fix rather than feature, maybe it should
> be considered for hardy-updates at the very least.
>
> --
> firefox crashes on flash contents
> https://bugs.launchpad.net/bugs/192888
> You received this bug notification because you are a direct subscriber
> of the bug.
>

Jeremy LaCroix wrote:
> I wouldn't consider using nspluginwrapper on 32-bit a fix just yet, as even
> on a 64-bit install with nspluginwrapper, Flash crashes still brings down
> the entire Firefox instance.

I have never seen that. In all instances where flash crashed on me, firefox was still responsive and fully functional except for the gray boxes where flash content was supposed to be(but there might have been more than one bug that got condensed into this one). There are other reasons seperate from this bug for using nspluginwrapper or something like it on 32-bit, namely that flash can run in a seperate process and therefore utilize a different core, which is very handy when flash is eating 100% cpu on something and you want to still browse the web.

> I think the only sensible solution is to
> include Pulse Audio, but don't turn it on by default, let the user turn on
> Pulse Audio if they want it. Pulse Audio is way too unstable and incomplete
> to even be considered for an LTS release.

Couldn't disagree more. We have a valid work around for 99% of users. A LTS system is not a system that never gets updated -- this simply remains a high priority bug until the Right Fix (tm) comes out. Besides, removing pulse audio at this late stage of the game is going to introduce way more breakage than leaving it as is.

ski (skibrianski) wrote :

On further re-reading of this thread, Jeremy, I think unfortunately the bug you are experiencing is almost certainly different than what most everyone else is experiencing (certainly different from what I am experiencing), particularly since you've had it since before gutsy.

  • unnamed Edit (2.1 KiB, text/html; charset=ISO-8859-1)

Well, as long as it gets fixed, I don't mind. It just seems to me that there
are way too many regressions to use Pulse as default.

On Tue, Apr 22, 2008 at 8:01 PM, ski <email address hidden> wrote:

> Jeremy LaCroix wrote:
> > I wouldn't consider using nspluginwrapper on 32-bit a fix just yet, as
> even
> > on a 64-bit install with nspluginwrapper, Flash crashes still brings
> down
> > the entire Firefox instance.
>
> I have never seen that. In all instances where flash crashed on me,
> firefox was still responsive and fully functional except for the gray
> boxes where flash content was supposed to be(but there might have been
> more than one bug that got condensed into this one). There are other
> reasons seperate from this bug for using nspluginwrapper or something
> like it on 32-bit, namely that flash can run in a seperate process and
> therefore utilize a different core, which is very handy when flash is
> eating 100% cpu on something and you want to still browse the web.
>
> > I think the only sensible solution is to
> > include Pulse Audio, but don't turn it on by default, let the user turn
> on
> > Pulse Audio if they want it. Pulse Audio is way too unstable and
> incomplete
> > to even be considered for an LTS release.
>
> Couldn't disagree more. We have a valid work around for 99% of users. A
> LTS system is not a system that never gets updated -- this simply
> remains a high priority bug until the Right Fix (tm) comes out. Besides,
> removing pulse audio at this late stage of the game is going to
> introduce way more breakage than leaving it as is.
>
> --
> firefox crashes on flash contents
> https://bugs.launchpad.net/bugs/192888
> You received this bug notification because you are a direct subscriber
> of the bug.
>

I've tried both the default.pa patch and the libflashsupport for a couple of days (always using nspluginwrapper in FF). My experiences were as follows:
- With the latest default.pa patch everything worked reasonable. Sometimes I heard sound stuttering (especially when using mplayer), even when I'm a member of all of the pulse groups (including pulse-rt). Flash did seem to crash pretty often (about 2 out of 5 times). Nspluginwrapper always prevented a hard FF3 crash.
- I later reverted back to the original default.pa (and installed libasound2-plugins, just in case). Everything still works, the stuttering is completely gone (even in mplayer), and Flash doesn't seem to crash so often.

linovski (avelinorego) wrote :

When I play sound from flash contents, movie player(I try totem and mplayer) only play one second of a movie.
I seek the movie position and the movie plays one second in the new position an them stops.

Is this a bug of this bug report, or is a different one?

Linovski -- that's the Flash player trying to play its audio, but
failing to and so hanging its video output while it waits indefinitely
for the audio to play.

I think it's because PA is using the audio device exclusively when you
start the Flash player.

Flash player always can play.
I can play youtube videos and at the same time listen last.fm radio (at firefox with flash support).
What I can't do, is playing video files from my disk, at the same time as flash play.
Normally I just need to close the flash tab. In some times I need completely close firefox, and just now play the video files with mplayer.

Conn O Griofa (psyke83) wrote :

linovski,

This bug is concerned with flash crashing while using libflashsupport. The purpose of libflashsupport is to allow flash to share sound with other pulseaudio-aware applications (without it, flash blocks sound from playing simultaneously with other applications, as you are experiencing).

You are probably having this issue because libflashsupport is not installed on your system. According to Alexander, libflashsupport will be reintroduced as a dependency on flash, but in the meantime you can manually install the package yourself. If you do this, however, you will experience sporadic Firefox crashes.

Please read the entire bug report carefully before asking more questions, as it's all explained here.

Alexander Jones (alex-weej) wrote :

From what I gather with my brief chat with Lennart Poettering just now, libflashsupport was necessary for older versions of Flash because of some nasty quirk in their use of ALSA (probing all available channels, which is significantly higher for PulseAudio than physical hardware, causing the player to choke hard), but which now seems not to be needed.

So, if this is correct, libflashsupport should be marked as CONFLICTS with flashplugin-nonfree.

The proper way to get Flash (and all other ALSA apps) using Pulse is to follow the steps in the summary of Bug 198453.

PLEASE TEST THIS! Remember to remove libflashsupport from your system!

Daniel T Chen (crimsun) wrote :
Download full text (23.8 KiB)

Using the original default.pa that ships in current hardy (opens hw:0 exclusively), using `asoundconf set-pulseaudio', and hotplugging a usb audio device results in inaudible audio for Flash.

From `pulseaudio -vv':

...
I: sink-input.c: Freeing output 1898 "ALSA Playback"
I: client.c: Freed 1901 "ALSA plug-in [firefox]"
I: protocol-native.c: connection died.
I: client.c: Created 1902 "Native client (UNIX socket client)"
I: protocol-native.c: Got credentials: uid=1000 gid=1000 success=1
I: protocol-native.c: Enabled SHM for new connection
I: client.c: Client 1902 changed name from "Native client (UNIX socket client)" to "ALSA plug-in [firefox]"
I: module-volume-restore.c: Restoring sink for <pulsecore/protocol-native.c$ALSA plug-in [firefox]>
I: module-volume-restore.c: Restoring volume for <pulsecore/protocol-native.c$ALSA plug-in [firefox]>
D: module-suspend-on-idle.c: Sink alsa_output.usb_device_d8c_c_noserial_if0_sound_card_0_alsa_playback_0 becomes busy.
I: sink-input.c: Created input 1899 "ALSA Playback" on alsa_output.usb_device_d8c_c_noserial_if0_sound_card_0_alsa_playback_0 with sample spec s16le 2ch 44100Hz and channel map front-left,front-right
D: memblockq.c: memblockq requested: maxlength=132300, tlength=88200, base=4, prebuf=84672, minreq=3528
D: memblockq.c: memblockq sanitized: maxlength=132300, tlength=88200, base=4, prebuf=84672, minreq=3528
D: module-suspend-on-idle.c: Sink alsa_output.usb_device_d8c_c_noserial_if0_sound_card_0_alsa_playback_0 becomes idle.
D: module-suspend-on-idle.c: Sink alsa_output.usb_device_d8c_c_noserial_if0_sound_card_0_alsa_playback_0 becomes idle.
I: sink-input.c: Freeing output 1899 "ALSA Playback"
I: client.c: Freed 1902 "ALSA plug-in [firefox]"
I: protocol-native.c: connection died.
I: client.c: Created 1903 "Native client (UNIX socket client)"
I: protocol-native.c: Got credentials: uid=1000 gid=1000 success=1
I: protocol-native.c: Enabled SHM for new connection
I: client.c: Client 1903 changed name from "Native client (UNIX socket client)" to "ALSA plug-in [firefox]"
I: module-volume-restore.c: Restoring sink for <pulsecore/protocol-native.c$ALSA plug-in [firefox]>
I: module-volume-restore.c: Restoring volume for <pulsecore/protocol-native.c$ALSA plug-in [firefox]>
D: module-suspend-on-idle.c: Sink alsa_output.usb_device_d8c_c_noserial_if0_sound_card_0_alsa_playback_0 becomes busy.
I: sink-input.c: Created input 1900 "ALSA Playback" on alsa_output.usb_device_d8c_c_noserial_if0_sound_card_0_alsa_playback_0 with sample spec s16le 2ch 44100Hz and channel map front-left,front-right
D: memblockq.c: memblockq requested: maxlength=132300, tlength=88200, base=4, prebuf=84672, minreq=3528
D: memblockq.c: memblockq sanitized: maxlength=132300, tlength=88200, base=4, prebuf=84672, minreq=3528
D: module-suspend-on-idle.c: Sink alsa_output.usb_device_d8c_c_noserial_if0_sound_card_0_alsa_playback_0 becomes idle.
D: module-suspend-on-idle.c: Sink alsa_output.usb_device_d8c_c_noserial_if0_sound_card_0_alsa_playback_0 becomes idle.
I: sink-input.c: Freeing output 1900 "ALSA Playback"
I: client.c: Freed 1903 "ALSA plug-in [firefox]"
I: protocol-native.c: connection died.
I: client.c: Created 1904 "Native client...

Conn O Griofa (psyke83) wrote :

The problem is a little more complicated.

Case 1. Default installation & asound.conf from bug #198453

a) Flash audio will play, but still hogs the sound card and does not show on the PulseAudio Volume Control applet. Checking .xsession-errors after flash playback shows the following line:

ALSA lib pcm.c:2106:(snd_pcm_open_conf) Cannot open shared library /usr/lib/alsa-lib/libasound_module_pcm_pulse.so

b) mplayer with forced ALSA output - does not work.
$ mplayer -ao alsa /usr/share/example-content/ubuntu\ Sax.ogg

(snip)
[AO_ALSA] alsa-lib: pcm.c:2106:(snd_pcm_open_conf) Cannot open shared library /usr/lib/alsa-lib/libasound_module_pcm_pulse.so
[AO_ALSA] Playback open error: No such file or directory
Could not open/initialize audio device -> no sound.
Audio: no sound
Video: no video
(snip)

Case 2. Default installation, libasound2-plugins & asound.conf from bug #198453

a) Flash does not produce audio output. Checking .xsession-errors does not show the error in Case 1.

b) mplayer with forced ALSA output - audio works, no error messages.
$ mplayer -ao alsa /usr/share/example-content/ubuntu\ Sax.ogg

(snip)
AO: [alsa] 44100Hz 2ch s16le (2 bytes per sample)
Video: no video
Starting playback...
(snip)

Conclusion: the proposal in bug #198453 *requires* libasound2-plugins package to be installed, helps with some applications but it still does not fix Flash, unfortunately.

Conn O Griofa (psyke83) wrote :

Alexander,

I forgot to mention that I did not have libflashsupport installed for the previous tests, as you requested. It seems that this isn't a solution.

I also tried the ALSA version of Skype (Case 2 configuration), manually set the sound devices to "pulse" and funnily enough, the Skype control appears in the PulseAudio Volume Control, Skype no longer shows any sound warnings/error, but no actual sound is produced, unfortunately.

Luke Yelavich (themuso) wrote :

Daniel has added some fixes to alsa-plugins, which need testing. In a short while, a test package will be installable using the following sources.list line for my PPA:
deb http://ppa.launchpad.net/themuso/ubuntu hardy main

If everybody who is experiencing the reported issues in this bug could give this package a test, it would be much appreciated.

Thanks.

cameo73 (jeroen-brattinga) wrote :

I tested the proposal mentioned in bug #198453 and reached the same conclusion as Conn.

For me simultaneous audio is only working in Flash if I use libflashsupport. My 'ideal setup' (the one where I can play all audio simultaneously) is
- using libflashsupport
- using libasound2-plugins
- ~/.asoundrc using the pulse driver (see bug #198453)

In that case I can play Flash (in FF3), Exaile! (using gstreamer) and both sound tests mentioned in bug #198453 simultaneously.

I also tested the latest libasound2-plugins from themuso repository, but did not notice any difference with the official one (they both work).

With Conn's nspluginwrapper package (comment 39) installed Hardy became useful to me on the desktop. Flash still crashes sometimes, but doesn't take Firefox with it anymore. I still have libflashsupport installed as I started with one of the betas and for example listening to music in rhythmbox while playing sound from a Flash video works fine (although I have to note that my SoundBlaster supports hardware mixing, don't know if that did the trick).

I hope there will be official packages for i386 soon. I know you cannot fix proprietary stuff like Flash, but while restrictions to our freedom are evil, unfortunately there is no working free alternative for Flash at the moment. So restricting our freedom and crashing essential applications is even worse and this workaround seems to help a lot.

Conn O Griofa (psyke83) wrote :

Luke & Daniel,

Using libasound2-plugins_1.0.15-1ubuntu3.1~ppa1_i386.deb doesn't help, but seems to be different.

When I try to play flash, there is no sound output, but pulseaudio log output goes nuts, seemingly opening and killing dozens of clients per second. Bear in mind the output I'm sending is from about 2 seconds of playback & it would continue ad nauseam if I did not kill the process. In The PulseAudio Volume Control program, Flash does have an entry, but it flickers, disappearing and reappearing extremely fast (not surprising if you look at the log).

There's a similar situation when trying Skype (ALSA version), I'll attach the log if you're interested. Funnily enough, Skype sometimes does produce audio, but it's an extremely rare occurrence and it soon crashes requiring a "killall -9". Skype has an entry in the PulseAudio Volume Control, but it remains stable unlike flash.

Conn O Griofa (psyke83) wrote :

Here's Skype's output too.

Alexander Jones (alex-weej) wrote :

OK, the reason it works fine on AMD64 is because libflashsupport is installed as part of ia32-libs.

Which raises the question -- why is there are 64-bit libflashsupport package? Total red herring.

So, I've honestly not noticed any issue with Flash, the test case here works fine with npviewer on AMD64. If there's some airbag style wizardry going on, maybe we should just push for using npviewer on I386 too and reinstate libflashsupport. SMP benefits, too.

Daniel T Chen (crimsun) wrote :

Conn's deb for nspluginwrapper works for me I have sound from libflashsupport and browser crashes are gone i know its not 100% fix but its usuable now.

8.04 Hardy Heron
System spec's (lshw output) are attached

description: updated
Conrad Knauer (atheoi) wrote :

From the modified description:

"Workaround for early Hardy adopters: Manually uninstall the libflashsupport via 'apt-get remove libflashsupport' or synaptic. This is necessary because libflashsupport would not automatically be removed by update-manager when it was changed from a dependent package to a recommended package during the Hardy development cycle."

Confirmed that it fixes the problem (or at least the nasty symptoms ;) for me! :)

Confirmed - without libflashsupport Firefox doesn't crash and Flash works. However, when playing sound in VLC/Totem/... I cannot hear sound in Flash without first closing down these programs. When playing sound from Flash (e.g. Youtube), I cannot hear sound from other programs without first restarting Firefox.

Is this related to this bug somehow? Is there a workaround?

Daniel T Chen (crimsun) wrote :

Macuyiko, see my comments in this bug (particularly the most recent, aside from this one, for a workaround. We need as many testers as possible).

Jeremy Nickurak (nickurak) wrote :

I too get inaudible audio from flash with asound pointed at the pulse plugin, until I install libflashsupport, at which point sound comes through, but the occasional firefox crashes come back (unless nspluginwrapper is installed, in which case flash will crash but not take firefox with it).

Daniel: Is that the workaround you were referring to?

Conn O Griofa (psyke83) wrote :

Jeremy,

That is one possible way to make sounds work correctly, but it is not what Daniel was referring to. Daniel was talking about comment #136 in which he has modified PulseAudio to use ALSA's dmix. To test this solution, you should probably remove nspluginwrapper and libflashsupport, otherwise it will cause confusion.

Daniel,

The PulseAudio developers seem to think it's a bad idea to use dmix... Perhaps it would be better if we reconfigure PulseAudio purely for ESD output, until these issues are cleared up.

I've also installed nspluginwrapper and installed libflashsupport again. Flash sound now work together with other apps... As of now Flash has not crashed (yet?).

> The PulseAudio developers seem to think it's a bad idea to use dmix...
> Perhaps it would be better if we reconfigure PulseAudio purely for ESD
> output, until these issues are cleared up.

Yes, let's do this. ESD is really broken and keeps crashing, so PA
will do as a drop-in. We need to change the default GST configuration
to use HALAudioSink again, so it gets access to DMix directly rather
than via PA (thus minimising the latency and resource usage).

Daniel T Chen (crimsun) wrote :

Conn, what do you mean by "ESD output"? The default GSt audiosink as shipped in hardy is pulsesink. Pulseaudio is invoked via ESD compatibility (cf. pulseaudio-esound-compat package). We do not need to make any changes in GSt or its configuration, because alsasink is attempted if pulsesink fails.

I think many people are missing the point of this protracted discussion, which is to avoid Firefox 3.0 beta 5 crashing repeatedly (whether deterministically or otherwise). Hardy shipped with this goal met for both i386 and amd64.

The issue that I am attempting to address is the nondeterministic inaudibility of Flash with random PulseAudio clients.

JLR (artirj) wrote :

Fix this before 8.04.1 please

trannypunk (trannypunk) wrote :

Conn's work around seems to have worked for me. Hardy/HP dv2415. Thanks!

JLR (artirj) wrote :

Conn's solution also works for me (Q6600, Asus P5K3 SE, 2gb ram, NVIDIA 8600GT homemade)
Good job!!

I had the same problem, Conn's work around seems to fix it for me. (Hardy, Dell M1330, Nvidia GF 8400 GS)

Jinx-Wolf (jinx-wolf) wrote :

Removing PulseAudio worked for me.

Carey Underwood (cwillu) wrote :

Has this been reported to adobe's bugtracker yet?

https://bugs.adobe.com/flashplayer/

Nothing shows up when I query it, it looks like it's open to the public (aka, developers from affected open projects)

Luke Yelavich (themuso) wrote :

In testing the fixes that Daniel added to the pulseaudio bzr branch, I've found that GNOME sound events don't work, due to sample caching limitations. The sample size has already been increased for use with LTSP, this is likely to break that even further.

On the other hand, using pulseaudio with dmix hasn't affected hibernate/resume and the use of audio after resume at all.

kindofabuzz (kindofabuzz) wrote :

my firefox crashes on some flash sites WITHOUT libflashsuppot installed =(

Loris B. (lorisboillet) wrote :

yes, it has been reported to adobe's bugtracker:

https://bugs.adobe.com/jira/browse/FP-146

And I guess it's not the first report that was made regarding this.

Oscar Abac (oscraf) wrote :

I install other browser the Netscape Navigator and Macromedia Flash plugin for linux and works fine, I use it until Firefoxguys fix it, perhaps in the non beta version.

I've libflashsupport uninstalled and I still crash every 2nd video.

Simon Morgan (sjmorgan) wrote :

I've just switched back from Arch, which doesn't use Pulse Audio, and the Flash plugin crashed Firefox (I'm using the nightly builds) just as much then.

John Vivirito (gnomefreak) wrote :

>
> ithendra Balakrishnan wrote:
>
>> > I've libflashsupport uninstalled and I still crash every 2nd video.
>> >
>> >
>>

did you remove libflashsupport.so from /usr/lib/mozilla/.... please make
sure and restart firefox and if it still crashes please follow
instructions on how to obtain a backtrace found at:
https://wiki.ubuntu.com/MozillaTeam/Bugs

--
Sincerely Yours,
    John Vivirito

https://launchpad.net/~gnomefreak
https://wiki.ubuntu.com/JohnVivirito
Linux User# 414246

Alexander Jones (alex-weej) wrote :

You may still have libflashsupport installed if you're on amd64. We
ship a pointless 64-bit version of the plugin in the actual
"libflashsupport" package, but the real 32-bit version is in
ia32-libs.

dpkg -S libflashsupport

Dani (danielfrechoso) wrote :

Here I have a 64 bit (2.6.24-16-rt) where the 64 bit version of libflashsupport was never installed and I have checked the /lib/mozilla......... thing to make sure that nothing "anoying" is installed, but still keeps on freezing when checking flash movies/animations.....

Good luck!

Xvani (fredrile+launchpad) wrote :

For me, it also crashes if I'm running another audio application (only tested with Amarok) and then starting a flash..

To reproduce:
Start Amarok
Play song
Start flash from youtube with audio
Sound stops playing on both devices after a while...

Is this a seperate bug, or same thing?
Hardy should not have been released with this bug.....

Arthur (moz-liebesgedichte) wrote :

Just an additional data-point, hoping it'll help someone:
On my AMD64 hardy system I'm using the 32 bit versions of Seamonkey stable and Firefox nightly builds (installed from ftp.mozilla.org in a user owned directory). I've had the here described problems with flash videos. After *installing* libflashsupport the crashes went away. That sounds a bit strange if all the package libflashsupport offers is a 64 bit library which shouldn't be used by the 32 bit versions. So it's possible that something else changed, but that's the only change I've done consciously.

jtaylor (jonathan-taylor) wrote :

I would love all this to work as it is supposed to with pulseaudio... but I found simply doing

apt-get remove libflashplugin pulseaudio

solved all my problems. Hope it helps someone.

Jonay (jonay-santana) wrote :

Same problem here. Both on a Xubuntu and Ubuntu (Gnome) 8.04. It crashes *always*, but after the crash, if I open Firefox again and choose to restore session, it works flawlesslyl... I don't understand a thing. :S Can I help in any way?

DalaiDakkar (dalaidakkar) wrote :

Had the same problem, when watching youtube content I couldn't hear sound from local files or movies, I installed libflashsupport wich solved this problem, but firefox crashes started, I followed Conn's workaround and until now crashes are gone. thanks Conn.

DalaiDakkar (dalaidakkar) wrote :

Update
Now the first crash, but firefox still running, only the flash part of the page become a grey square not showing flash content, but now even if I reload or close the tab and reopen the gray square is still there :(

If you are going for some heavy flash surfing and need libflashsupport to have sound then I have a workaround. Open a flash video and if it doesn't crash pause it. Do your regular flash surfing in another tab without closing the first one and you shouldn't have a problem.

I've had a different bug... the back button stops working on ffox after the flash plugin is installed.

ski (skibrianski) wrote :

Paul: If you have a different bug, please don't contribute to the noise here - file a seperate bug report for that problem.

Maurizio Moriconi (bugman) wrote :

Installing flashplayer 10 beta seems to solve crash.

Doctor P (coffeeonmars) wrote :

I confirm that installing flashplayer 10 beta and libflashsupport solves crashes and problems with other audio applications.
Installing only flash 10 without libflashsupport does not let other applications play sound while a flash video is playing.
With both installed, flash player does not block audio output from other applications and can be launched and play sound when some sound is already being playing. In the same condition, flash 9 + libflashsupport crashed and flash 9 without libflashsupport did not play audio.

Conn O Griofa (psyke83) wrote :

Hi,

Adding to Doctor P's feedback:

a) flash 10 + libflashsupport = audio works with pulseaudio
b) flash 10 without libflashsupport = audio does not work with pulseaudio
c) flash 10 without libflashsupport + fixes proposed in bug #198453 = audio works with pulseaudio

This bug now depends on #198453. Option (c) is clearly the best solution. We can also forget about nspluginwrapper as long as these crashes have indeed stopped (but it will do no harm to keep it).

ski (skibrianski) wrote :

Conn, why can we forget about nspluginwrapper? I thought it was you who first extolled its benefits in terms of performance and reliability?

Conn O Griofa (psyke83) wrote :

ski,

We can forget about nspluginwrapper (and libflashsupport) to reduce complexity, that's all. With versions of Flash prior to v10 beta, the basic equation was:

a) Flash = audio is not directed to PulseAudio, therefore sounds cannot mix. However, Flash does not crash.
b) Flash + configuration proposal in bug #198453 = Flash does not successfully pass audio to PulseAudio
c) Flash + libflashsupport = audio is directed to PulseAudio, Flash crashes sporadically causing Firefox to crash.
d) Flash + libflashsupport + nspluginwrapper = audio directed to PulseAudio, Flash crashes sporadically but Firefox does *not* crash.

You can see that our options were limited, but (d) was clearly the best option.

As for performance benefits, you're misquoting me. Somebody else mentioned that nspluginwrapper helps on multi-core systems; I only have single-core systems so I cannot comment.

Flash v10 now seems to cooperate with the "pcm_pulse" ALSA plugin natively (as I mentioned in my last post), so we have a new & better option (i.e. just to fix bug #198453).

For i386 users, I posted an updated flashplugin-nonfree package here if you want to do some testing: http://ubuntuforums.org/showthread.php?p=4928900
See Part B, but Part A is a prerequisite (i.e. to apply the fixes of bug #198453).

JLR (artirj) wrote :

I agree with Conn. Im playing a youtube video and each of my 4 cores handle a bit of it. D is better.
This bug is Public Enemy #1, i hope we can get the flash 10 final on hardy before 8.04.1

ski (skibrianski) wrote :

Conn - Ah, sorry, looking back it seems you pointed out the stability benefits of nspluginwrapper (in theory). I was the one who advocated it for performance reasons :-) But thanks for clarifying all the cases, that's handy info to have around.

Simon Morgan (sjmorgan) wrote :

The Flash 10 beta still crashes here.

Conn O Griofa (psyke83) wrote :

Simon, do you still have libflashsupport installed? If so, remove it and add the proper configuration to /etc/asound.conf; see bug #198453.

Conn O Griofa (psyke83) wrote :

Simon, I just saw your earlier comment re: Arch. If you're experiencing crashes even without PulseAudio, then it's a bug in Flash and not related to this report. Please read the original description of this report properly.

Doctor P (coffeeonmars) wrote :

Quick correction: installing flash 10 and libflashsupport (without ndspluginwrapper) still causes firefox crashes. Removing libflashsupport and correcting asound.conf seems to have solved everything...
Thanks Conn and ski!

Doctor P (coffeeonmars) wrote :

Mistake: removing libflashsupport blocks the audio, installing it makes it work :)

Alexander Jones (alex-weej) wrote :
  • unnamed Edit (93 bytes, text/html; charset=ISO-8859-1)

Are you absolutely sure that it is libflashsupport crashing firefox? Check
with a trace.

Conn O Griofa (psyke83) wrote :

Message from Lennart Poettering on upsteam's mailing list:

https://tango.0pointer.de/pipermail/pulseaudio-discuss/2008-May/001796.html

<snip>
"The current version of Flash relies on snd_async_add_pcm_handler() to
be available in ALSA in all cases. This is ugly (especially from a
plugin, since it relies on unix signals), and broken (since they don't
properly handle the signal handler context) and cannot be properly
supported in the PA backend for libasound (unless we'd resort to some
exceptionally ugly hacks, which would have no chances to get
upstream to alsa-plugins)."
<snip>

Please, read the rest of the message, and he explains why libflashsupport causes instability.

The good news is that it appears Flash 10 beta now cooperates with the pcm_pulse ALSA plugin, so we can avoid using libflashsupport entirely if we can get the proper asound.conf configuration (that should have been present for release) enabled. Of course the "beta" tag on Flash will not help this case, but at least we can feel confident the next stable release of Flash should work ok.

Ben (b3nw) wrote :

Interestingly enough I also had this problem.

But when I installed the http://flashblock.mozdev.org/ extension on firefox, I no longer had the issue. Something to do with not permitting everything to auto load, and allowing me to one by one click flash I wanted to see blocked the issue.

This is not a fix, but a good bandaid for those who want to use it + pulseaudio.

Luke Yelavich (themuso) wrote :

Talking to the upstream PulseAudio developer/author, it appears tat Flash 9 has a race condition that cannot be worked around at all in libflashsupport. Unfortunately we will have to wait till Flash 10 to be able to use libflashsupport successfully, and from what users are already saying, flash 10 beta seems to have addressed the issue.

Ben (b3nw) wrote :

Can confirm that manual flash 10 beta install produces no crashes with
libflashsupport.

-Ben

On May 20, 2008, at 3:17 AM, Luke Yelavich wrote:

> Talking to the upstream PulseAudio developer/author, it appears tat
> Flash 9 has a race condition that cannot be worked around at all in
> libflashsupport. Unfortunately we will have to wait till Flash 10 to
> be
> able to use libflashsupport successfully, and from what users are
> already saying, flash 10 beta seems to have addressed the issue.
>
> --
> firefox crashes on flash contents when using libflashsupport
> https://bugs.launchpad.net/bugs/192888
> You received this bug notification because you are a direct subscriber
> of the bug.

Daniel T Chen (crimsun) wrote :

The "proper asound.conf configuration" has been available since gutsy. We even provide `asoundconf set-pulseaudio' (per-user). Edubuntu has been using it system-wide for those releases.

Daniel T Chen (crimsun) wrote :

We should (re)close the pulseaudio and linux tasks. We just need the newer Flash 10 beta in intrepid (and hardy-backports).

Well, ok, not quite that straightforward, so I'll cover intrepid (first):

flashplugin-nonfree (10 beta) needs a Conflicts on libflashsupport; flashplugin-nonfree should also have (versioned, if possible) Recommends (possibly Depends, but we should be mindful of OSSv4 here, too) on libasound2-plugins and alsa-utils (haven't checked this last one - not current on seed structure).

libflashsupport needs a versioned Conflicts on the newer flashplugin-nonfree.

libasound2-plugins should ship a system-wide asound.conf set to pcm & ctl pulse.

Alexander Jones (alex-weej) wrote :
  • unnamed Edit (142 bytes, text/html; charset=ISO-8859-1)

Daniel, a reminder -- the "libflashsupport" package is bogus, and does
nothing on AMD64. It needs removing from ia32-libs here.

Conn O Griofa (psyke83) wrote :

Daniel,

It's good that we can use set-pulseaudio per-user (that will allow GDM access to the sound card, unlike with a global /etc/asound.conf due to PulseAudio not running system-wide), but it should be set *by default* without user intervention.

Also, it is critical for the "libasound2-plugins" package to be available, as the required plugins are in that package,
i.e. "/usr/lib/alsa-lib/libasound_module_ctl_pulse.*" and "/usr/lib/alsa-lib/libasound_module_pcm_pulse.*". Hardy does not install this package by default, and will silently fail to pass ALSA applications to PulseAudio, so it needs to be added as a dependency somewhere.

Conn O Griofa (psyke83) wrote :

Daniel,

Sorry, I see you mentioned libasound2-plugins.

Let me just add that if you set a system-wide /etc/asound.conf then everything will work except GDM's login sound. If an ALSA application routes audio through the pcm_pulse plugin while no PulseAudio server is running, it simply gives a "connection refused" error message and no audio plays.

A solution is to use per-user configuration, or to patch pcm_pulse so that if a PulseAudio server is not available, then bypass directly to the normal (dmix?) interface.

vpbalint (vpbalint) wrote :

I had the same problem too but I removed the alsa-oss package and now everything looks fine...

Vytas (vytas) wrote :

I don't like the idea of automatic per user asound.conf. It is just messy and unneeded.
If GDM is broken in the current perspective, fix it

Jeremy Nickurak (nickurak) wrote :

How hard would it be to simply have gdm run a pulseaudio server until a user is actually logged in?

Alexander Jones (alex-weej) wrote :
  • unnamed Edit (170 bytes, text/html; charset=ISO-8859-1)

That's what Lennart seemed to suggest to me when I brought these issues up a
while ago. I still think a system-wide PA instance is the best approach, but
whatev.

Daniel T Chen (crimsun) on 2008-05-20
Changed in flashplugin-nonfree:
assignee: nobody → crimsun
status: Fix Released → In Progress
Changed in pulseaudio:
status: In Progress → Invalid
status: In Progress → Invalid
milestone: ubuntu-8.04.1 → none
milestone: ubuntu-8.04.1 → none
Changed in linux:
status: New → Invalid
status: New → Invalid
Changed in libflashsupport:
assignee: nobody → crimsun
status: Confirmed → In Progress
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package libflashsupport - 1.9-0ubuntu2

---------------
libflashsupport (1.9-0ubuntu2) intrepid; urgency=low

  * debian/control: Conflict with flashplugin-nonfree versions older
    than intrepid's while allowing for backports (LP: #192888).

 -- Daniel T Chen <email address hidden> Tue, 20 May 2008 17:09:01 -0400

Changed in libflashsupport:
status: In Progress → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package flashplugin-nonfree - 10.0.1.218ubuntu1

---------------
flashplugin-nonfree (10.0.1.218ubuntu1) intrepid; urgency=low

  * New upstream beta fixes many crashers (most significantly
    LP: #192888).
  * debian/config:
    debian/postinst: Update md5sums, filenames, and paths. Remove
    debugging bits (LP: #176226).
  * debian/control: Readd versioned dependency for libflashsupport|
    libasound2-plugins to play nicely with either PulseAudio config
    while preserving OSSv4 users' ability to have audible "shiny"
    (LP: #206307, #186726, #183943, #151849).

 -- Daniel T Chen <email address hidden> Tue, 20 May 2008 16:34:40 -0400

Changed in flashplugin-nonfree:
status: In Progress → Fix Released
Alexander Jones (alex-weej) wrote :

I've added an ia32-libs task to get rid of flashplugin-nonfree in there for amd64 users.

liorda (liorda) wrote :

this bug is very annoying. is there a solution?

Vytas (vytas) wrote :

Yes, install flashplayer 10 beta, libasound and alsa-plugins from intrepid, remove libflashsupport, and configure alsa to use pulseaudio.
Works for me

John Vivirito (gnomefreak) wrote :

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Vytas wrote:
| Yes, install flashplayer 10 beta, libasound and alsa-plugins from
intrepid, remove libflashsupport, and configure alsa to use pulseaudio.
| Works for me
|
Flash 10 will show up in all supported ubuntu versions very soon as it
just was pushed to Intrepid. In the mean time you can remove
libflashsupport until the update gets pushed to Your version of Ubuntu.
Once you get flash 10 it will install libflashsupport because it needs
it and has fixed it very nice so far. the package will start off in
$codename-proposed than it will be pushed into $codename-security im
fairly sure this will fit the terms to get in security if not it will
hit backports.

- --
Sincerely Yours,
~ John Vivirito

https://launchpad.net/~gnomefreak
https://wiki.ubuntu.com/JohnVivirito
Linux User# 414246
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.6 (GNU/Linux)
Comment: Using GnuPG with Mozilla - http://enigmail.mozdev.org

iD8DBQFINlEeqig4QTwcPCoRAlvcAJ9YL3UKc2mdhfbB1LnyLb7qg4mXdACfdJu3
a2A8q19V9Ix2ltWxFrxGKNU=
=D82U
-----END PGP SIGNATURE-----

ski (skibrianski) wrote :

Huh? We're going to be pushing a new version of flash (which is still in beta) to the -security branches? Or did you mean it would be pushed to -updates ?

Alexander Jones (alex-weej) wrote :
  • unnamed Edit (90 bytes, text/html; charset=ISO-8859-1)

I doubt it will be pushed at all until it hits stable. It's still beta,
remember.

cameo73 (jeroen-brattinga) wrote :

FF3 is still beta ... and was included in a LTS release! FWIW, I think the Flash 10 beta solves a lot of problems! (but is not a silver bullet, since I still see it crash -- probably due to Compiz or X related stuff)

What is this beta talk about, it is ridiculous. You have a "stable" version of Flash, that crashes Firefox every few minutes, even more on youtube and other sites. If there is another version called "Beta" that works fine with PulseAudio in a decent setup, switch over.

I know this is no discussion forum, but I am really pissed off so you must apologize. BTW, I tried Flash 10 Beta and together with Hardy's libflashsupport it kept crashing. I didn't try libasound and alsa-plugins setup from Intrepid though.

Will (war59312) wrote :

Still crashes every time on http://www.bwin.de/ after installing the new version.

ski (skibrianski) wrote :

Interesting, that site (bwin.de) crashes my flash too, but it does not crash firefox. I have had only sporatic flash problems since things settled down. Amd64 here.

ski@ganiodayo:~$ dpkg -l | grep -i -e firefox -e flash -e nspluginwrapper
ii firefox 3.0~b5+nobinonly-0ubuntu3 meta package for the popular mozilla web bro
ii firefox-3.0 3.0~b5+nobinonly-0ubuntu3 safe and easy web browser from Mozilla
ii firefox-3.0-gnome-support 3.0~b5+nobinonly-0ubuntu3 Support for Gnome in Mozilla Firefox
ii firefox-gnome-support 3.0~b5+nobinonly-0ubuntu3 meta package pointing to the latest gnome-su
ii flashplugin-nonfree 9.0.124.0ubuntu2 Adobe Flash Player plugin installer
ii libflashsupport 1.9-0ubuntu1 Support library for sound output of Flash 9
ii mozilla-firefox-locale-en-gb 2.0.0.7+1-0ubuntu4 Mozilla Firefox English language/region pack
ii nspluginwrapper 0.9.91.5-2ubuntu2 A wrapper to run Netscape plugins on other a
ii ubufox 0.5-0ubuntu1 Ubuntu Firefox specific configuration defaul

Jeremy Nickurak (nickurak) wrote :

Firefox is still segfaulting here after watching 2-3 youtube videos with flashplayer 10 beta. Tested it with and without libflashsupport installed.

This is no silver bullet.

Jeremy Nickurak (nickurak) wrote :

I should point out that I am using the pulse plugin via /etc/asound.conf, and libasound2 from intrepid (although packages.ubuntu.com reports libalsa2-plugins is the same version in hardy and intrepid currently...)

Conn O Griofa (psyke83) wrote :

Jeremy,

Ensure you have the correct configuration enabled (your post suggests you do) and that libflashsupport is *not* installed, and disable compiz. Maybe I'm crazy, but I could have sworn I saw a "Known Issues" entry mentioning instability when using compiz because of XRender, but I can't seem to find it in the release notes of Flash anymore.

Also, if you're using 64bit Ubuntu, libflashsupport is actually provided in the "ia32-libs" package, I think.

Peter Berry (pwberry) wrote :

I've been using nspluginwrapper for Flash for quite a long time now, and it has always been much less annoying to have just the plugin crash than the whole browser. I take the view that proprietary binary blobs are almost as bad in the browser as in the kernel, so any step to uncouple them is good IMO. (Obviously it would be best if the Flash plugin were made open source and/or Flash itself opened up, but that's up to Adobe.)

BTW Conn, while your nspluginwrapper package works, I'm intrigued as to what exactly it does. Does it have special magic for the Flash plugin or does it work for others as well?

Arthur (moz-liebesgedichte) wrote :

As I've said in comment 162 I haven't had a single crash with Seamonkey stable or current Firefox nightlies installed from the Mozilla servers since installing libflashsupport and nspluginwrapper on my AMD64 Hardy system. A simple ~/.mozilla/plugins/libflashplayer.so -> /usr/lib/flashplugin-nonfree/libflashplayer.so symlink enables the flash plugin. So what I would be interested in is whether people affected by this bug see it with the "official" builds from ftp.mozilla.org. If we're lucky it's some sort of incompatibility between the Hardy firefox/xulrunner-1.9 builds and flash. I've had exactly the issue as described here before and haven't seen it since.

Arthur (moz-liebesgedichte) wrote :

Just a little followup: I've installed Seamonkey and Firefox as user by extracting the tar.gz/tar.bz2 archives into directories in my home directory, not by replacing the system installs.

Conn O Griofa (psyke83) wrote :

Peter, I simply took the 64bit Ubuntu source and hacked it to work on 32bit architectures. Here's a page describing nspluginwrapper: http://gwenole.beauchesne.info//en/projects/nspluginwrapper

Arthur, I'm not sure if your experience will necessarily reflect other users, as libflashsupport seems to be packaged in the "ia32-libs" package for 64bit users. I noticed on the PulseAudio list there was a user requesting assistance (regarding this bug, IIRC), and he was convinced libflashsupport wasn't enabled, because he uninstalled the "libflashsupport" package. He was wrong, however, and libflashsupport was active all the time. This confusion should be addressed with regards to the packaging for 64bit users.

Arthur (moz-liebesgedichte) wrote :

@Conn: Yes, I know that libflashsupport is part of ia32-libs. I've just retested and can't reproduce the crashes with or without the (unnecessary) libflashsupport package. So it was something else that made the crashes go away. By the way I can play dozens of different flash videos concurrently all together producing a quodlibet/cacophony of audio output, no problem whatsoever. Probably people could try a ftp://ftp.mozilla.org/pub/firefox/nightly/latest-trunk/firefox-3.1a1pre.en-US.linux-i686.tar.bz2 build to see whether they see the issue with that version.

André Pirard (a.pirard) wrote :

Not sure what I'm experimenting relates to this thread.
Because I didn't find what you call your "crash".
Mine is Firefox abruptly disappearing without any message.
"tail -n 100 /var/log/*.log | grep firefox" is empty
It almost only occurs when I'm reading (belgian) Google News.
I launch a couple of articles from the summary page.
Then I get a crash, probably from some Flash ad.
That's rather often and a pest.
Other kind of browsing is cool, but less ads too.
I think I have pinpointed a culprit.
http://www.lepoint.fr
They probably run some harmful flash.
While it lasts, of course.
I'll try to keep keeping an eye open.
This is plain Hardy Release + imbedded Firefox + 84 updates.
Please redirect this report if misplaced.
I'll watch this bug for a while to answer any questions.

After trying both the hardy libasound2-plugins and libasound2 packages, and then trying the same packages with a few backported fixes relating to the pulseaudio alsa plugin, and creating an .asoundrc file with asoundconf set-pulseaudio, I never get any sound from flash in firefox at all, and this is on two different machines, both i386, not using any nspluginwrapper of any kind. Until flash 10 is final, I don't see the alsa-plugins solution as optimal at all, unfortunately.

Conn O Griofa (psyke83) wrote :

Luke,

When you say that you cannot get sound from flash, are you referring to flash 9? Currently, our only "sane" options are:

1. Flash 9 + libflashsupport + nspluginwrapper. This is suboptimal as it does not prevent flash from crashing, it merely provides a layer of protection to prevent Firefox from crashing with flash.

2. Flash 10 + bug #198453 configuration - libflashsupport. This configuration allows flash sound to get routed through pulseaudio without any crashes.

I wrote a guide on the forums to set up this second option, and nobody has complained about Flash since. I have been using Flash 10 non-stop and Firefox has not crashed a single time, even after extended browsing on flash-enabled sites.

Yes, you may argue that point 2 is not attractive as flash 10 is a beta version, but if it is the most functional solution, then I believe it merits testing at the very least. Since intrepid already has the beta flash plugin packaged, why don't we include it in hardy-backports?

cameo73 (jeroen-brattinga) wrote :

Could we stop with the "is not attractive as it's a beta"-comments? As has been said before: what situation do you choose: a 'final' that crashes a lot, or a beta that's rock solid?

For the record: I have the same experience as Conn (pretty stable with Flash 10 beta). Firefox 3 RC1 adds even more to the overall stability (i.e. it seems to solve any other non-pulse related crashes).

Jeremy Nickurak (nickurak) wrote :

I for one cannot get firefox to stop crashing once flash beta 10 + pulseaudio is installed (with or without libflashsupport), and no, I'm not running compiz. (I am using xcompmgr for transparency though).

To be clear, what's the perfect setup to be running flash beta 10 + pulseaudio simultaneously?

wvarner (winshipvarner) wrote :

Here is the step-by-step process by which I was able to get Firefox working with flash beta 10 + pulseaudio (it stopped the crashes - yay!). In this tutorial I've merely cobbled together in one place suggestions scattered around on this forum.

http://wvarner.blogspot.com/2008/05/firefox-crashing-on-youtube-in-ubuntu.html

Hope this helps!

Jeff Fortin Tam (kiddo) wrote :

Wvarner, thanks for the nice tutorial. I tried what you wrote there, but unfortunately, it does not solve the problem on my end. I still get the exact same crashes when I close a tab (with ctrl-W) that is playing a youtube video. Note that this was while I was playing music with rhythmbox, and with the epiphany browser (gecko version).

What is interesting is that with firefox, it indeed doesn't crash. It does crash with epiphany when I close tabs however (but this is 100%, positively due to flash, from my testing).

Phil (neo6238-ubuntu) wrote :

I am pretty sure, that this is the same bug! Konqueror always crashes on sites with much flash! One video from youtube is not a problem, but many flash elements are! I tried Firefox on of the sites and it crashes, too! :-(

Jamesnichols (nicholscabin) wrote :

I've tried as hard as I can to be a Linux supporter. But when simple things like watching YouTube are a problem it just makes me sick. How can Linux ever be "For the People" when the simplest things just don't work? It's pathetic and needs to be addressed before ANYBODY will abandon Windows.

I'm sorry you're having those problems, I would suggest trying a
different Linux distribution, because from my experience, this Flash bug
is Ubuntu-specific because I've never had problems with Flash on any
other distribution even on the same machine. IMHO, this bug is the only
thing keeping Ubuntu from being the absolute best distro.

Jamesnichols wrote:
> I've tried as hard as I can to be a Linux supporter. But when simple
> things like watching YouTube are a problem it just makes me sick. How
> can Linux ever be "For the People" when the simplest things just don't
> work? It's pathetic and needs to be addressed before ANYBODY will
> abandon Windows.
>
>

Arthur (moz-liebesgedichte) wrote :

I still think that some blame is to be put to ubuntu's firefox package. Even though it may trigger a bug in the flash plugin itself it seems to be significantly different to the official firefox releases from mozilla.org which don't trigger this bug and don't crash.

Changed in firefox:
status: Invalid → Incomplete
Breathe (mrcaudevilla) wrote :

I'm sorry for those guys having problems with Ubuntu distro... but i'm not having any problem people blame of... perhaps for me Ubuntu is the best distro linux can have. I have and AMD64 and i can have other audio and video programs opened while i play flash contents and also java content since OpenJDK arrived... Sorry for those that don't have the same chance... if it helps i could send the list of packages that i have installed to make Ubuntu work in this aspects.

"Microsoft gives you windows, while Linux gives you the house"

Alexander Jones (alex-weej) wrote :

Jamesnichols, and anyone else it may apply to:

Leave this kind of waste discussion elsewhere. It doesn't help us for you to troll on bug reports.

sotiris (sotiriss) wrote :

wvarner's solution worked for me. No crashing for Firefox anymore and i can play .mp3 from a player (Amarok) at the same time. Thanks a lot.

Jamesnichols (nicholscabin) wrote :

I've just deleted libflashsupport and now have absolutely no problems watching YouTube. Thanks for the guidance.

Someone left me a nasty email saying that I was "Trolling". That's too bad. I'll stand by my First Amendment Freedom of Speech and say what I think needs to be said. If people can't handle constructive criticism then they may be in the wrong business. This operating system isn't just something that I use for fun. I depend on it for my business every single day and expect it to work properly when released. Windows is the one who is supposed to release things before they're ready, not Linux.

John Vivirito (gnomefreak) wrote :

Jamesnichols wrote:
> I've just deleted libflashsupport and now have absolutely no problems
> watching YouTube. Thanks for the guidance.
>
> Someone left me a nasty email saying that I was "Trolling". That's too
> bad. I'll stand by my First Amendment Freedom of Speech and say what I
> think needs to be said. If people can't handle constructive criticism
> then they may be in the wrong business. This operating system isn't
> just something that I use for fun. I depend on it for my business every
> single day and expect it to work properly when released. Windows is the
> one who is supposed to release things before they're ready, not Linux.
>
This has been fixed in Flash 10 it now depends on libflashsupport and
has fixed alot of issues If you are using Hardy i have built flash 10
and libflashsupport for Hardy and im waiting to hear back on where we
want to upload this as it fits backports as well as -proposed than -updates.
My PPA is at: https://edge.launchpad.net/~gnomefreak/+archive
I just fixed libflashsupport depends It is built and ready to be used.
You will want to just download them at this time please dont addd the
repo to your sources.list file as soon i will be building some testing
packages that may not be ready for user use but the will be tested by a
few of us

--
Sincerely Yours,
     John Vivirito

https://launchpad.net/~gnomefreak
https://wiki.ubuntu.com/JohnVivirito
Linux User# 414246

Breathe (mrcaudevilla) wrote :

John Vivirito: Same problems with Flash 9, and with your new update... :(

It seems to be the same thing for me. My Firefox doesn't crash, but, if I am playing around with flash content and opened last FM radio station a warning pop out advising me that the ALSA framework for my sound card was in use (so no mixing available). This issue doesn't happen to me with any other audio/video program. If i do it the other way... Last FM running and open after it Firefox with flash content, it sometimes gets stuck when it has played for about 2 seconds (played with no sound)

Jamesnichols: You are a pain in the neck. This is a site for "bug reports", it's not a forum or a blog where constructive or non-constructive criticism is welcomed. And i really doubt that flash content is important for your business, don't victimize yourself.

sotiris (sotiriss) wrote :

John Vivirito : I confirm that the issue has been fixed in Flash 10. I've downloaded your libflashsupport and works fine.
Sotiris

the packages work fine for me too (amd64 architecture, firefox 3.0~rc1+nobinonly-0ubuntu0.8.04.1).

max (maxozilla) wrote :

Just installed these packages for hardy, still causes firefox to crash

keithyw (spamme-kwpro) wrote :

I've had the frequent Firefox crashing problem too. But in this case, I was using Firefox 2.0.0.14 that I had installed (along with a hand installed Flash 10 Beta). But I had more severe problems that would include whole system lock ups. I would be view a site with Flash enabled (usually those that have some form of sound) and perform some other activity. Then randomly my system would lock up and the sound bit would go into an infinite loop. Or I might be playing a video (for instance) with mplayer, go to a site with Flash enabled and my system would freeze.

I've tried using the solution proposed on the link below:

http://ubuntuforums.org/showthread.php?p=4928900

However, that actually would cause other media that seems to be using some form of audio to halt (e.g. mplayer as I'm watching a movie) or simply crash altogether.

Now, while I'm sure that this is a Flash and PulseAudio problem partly, I'm not certain if it's entirely the culprits. I have two systems with Ubuntu Hardy running. A Dell Inspiron 600M with a similar setup as my Desktop which is a SD30G2 that I built (i.e. they both have a hand installed Firefox 2.0.0.14 with a hand installed Flash plugin). My Dell operates just fine with all Flash content thus far, although I have not tried playing Flash content simultaneously with something else using audio on the system. My desktop though has been acting strangely. Perhaps, because I use an NVIDIA card, which seemed to cause me a lot of grief since upgrading from 7.0.4. I'm not sure if my system lock ups on my desktop are a combination of the hardware, PulseAudio and Flash.

Anyway, this is a pretty freaky bug and I'm curious to hear if anyone else has encountered something similar.

mneagul (mneagul) wrote :

keithyw: for system freezes caused by mplayer/totem/etc please see https://bugs.launchpad.net/ubuntu/+source/xorg/+bug/232275 or fill a new bug. The bug is fixed in upstream.

shemeshg (shemeshg) wrote :

To sum up I think that
1. Installing 'FlashBlock' and running flashes selectively might be a temporary proper walk around until Flash 10 is released.

2, as suggested manually upgrading to Flash 10.

max (maxozilla) wrote :

I disagree with the previous suggestions, because I have Flash 10 installed and Firefox still crashes after watching 2 or 3 flash videos with audio. I'm using PulseAudio.

shemeshg (shemeshg) wrote :

To sum up with Cristian T. Moecke and Max and shemeshg:
***************************************
*** Currently no solution for this issue. ***
***************************************

- Using 'FlashBlock' firefox add-on is a temporary walk around, since using it enable you to watch youtube and other flash sites without crashing your machine.

max (maxozilla) wrote :

I have now found a solution:

1. Open a terminal
2. Run:

 sudo gedit /etc/apt/sources.list

3. Add the following line and save:

deb http://ppa.launchpad.net/gnomefreak/ubuntu hardy main

4. Run:

sudo apt-get install flashplugin-nonfree libflashsupport

5. Follow the instructions at: http://www.pulseaudio.org/wiki/FlashPlayer9Solution to install a replacement libflashsupport.so

6. Restart Firefox

Flash 10 with PulseAudio on Ubuntu Hardy now works without crashing.

max (maxozilla) wrote :

* Also to note regarding the instructions at http://www.pulseaudio.org/wiki/FlashPlayer9Solution that I did not need to edit configure.ac as it advises.

max (maxozilla) wrote :

OK I eat my words. I'd refreshed a youtube page with flash and audio content numerous times and it hadn't crashed. And now it just did.

max (maxozilla) wrote :

I now tried with the official Flash 9 packages and then the patched libflashsupport.so provided by PulseAudio. It still crashes but again is happening far less frequently than before - now after roughly 10 page refreshes rather than 3.

Jeremy Nickurak (nickurak) wrote :

Can we please remove the "fix released" tag from this bug now?

I know this is frustrating. Nobody here can directly affect the situation, because adobe won't release the source code to flash so we could just fix it ourselves. Consequently it seems like there's about 3 avenues worth persuing:

- Pleading to Adobe to get its plugin working right (this might be something an organization as large as ubuntu + a few other distributions could pull off)
- Altering firefox so that it doesn't crash just because a plugin misbehaved (hard)
- Pouring effort into an open-source flash implementation like gnash (for now and in perpetuity, as people well certainly keep using every new feature Adobe squeezes into flash)

max (maxozilla) wrote :

OK I followed the instructions at http://wvarner.blogspot.com/2008/05/firefox-crashing-on-youtube-in-ubuntu.html and now it really does seem to be working fine (until the next crash ha)

max (maxozilla) wrote :

Just noticed that I still have stuff from GIT lying around, so it seems the following instructions may actually fix the problem:

1. Uninstall flashplugin-nonfree and libflashsupport (sudo apt-get remove)

2. Follow the instructions at http://wvarner.blogspot.com/2008/05/firefox-crashing-on-youtube-in-ubuntu.html

3. Then follow instructions at: http://www.pulseaudio.org/wiki/FlashPlayer9Solution

Should now work.

Conn O Griofa (psyke83) wrote :

max,

Please read the entire bug report before posting, it's already been discussed. The FlashPlayer9Solution page gives instructions to manually build the libflashsupport.so library that is *already* part of the "libflashsupport" package (that you tell us to remove in the first step), so your instructions are redundant.

Flash 9 + libflashsupport = crash
Flash 9 without libflashsupport + proper asound.conf configuration = no audio
Flash 10 + libflashsupport = crash
Flash 10 without libflashsupport + proper asound.conf configuration = works

My previous posts have discussed this and linked to the upstream mailing list; Lennart Poettering has even confirmed that Flash 10 works with the pcm_pulse plugin. Unfortunately flash 10 has its own quirks, entirely independent from PulseAudio. Using a composite manager (compiz, xcompmgr etc.) appears to cause some instability for some users (but not all).

If you want an unoffical "fix", then follow my guide here (although it's only providing instructions to configure PulseAudio as per upstream's "PerfectSetup", and such changes may come to hardy-proposed eventually: http://ubuntuforums.org/showthread.php?p=4928900

John Vivirito (gnomefreak) wrote :

Conn wrote:
> max,
>
> Please read the entire bug report before posting, it's already been
> discussed. The FlashPlayer9Solution page gives instructions to manually
> build the libflashsupport.so library that is *already* part of the
> "libflashsupport" package (that you tell us to remove in the first
> step), so your instructions are redundant.
>
> Flash 9 + libflashsupport = crash
> Flash 9 without libflashsupport + proper asound.conf configuration = no audio
> Flash 10 + libflashsupport = crash
> Flash 10 without libflashsupport + proper asound.conf configuration = works
>
> My previous posts have discussed this and linked to the upstream mailing
> list; Lennart Poettering has even confirmed that Flash 10 works with the
> pcm_pulse plugin. Unfortunately flash 10 has its own quirks, entirely
> independent from PulseAudio. Using a composite manager (compiz, xcompmgr
> etc.) appears to cause some instability for some users (but not all).
>
> If you want an unoffical "fix", then follow my guide here (although it's
> only providing instructions to configure PulseAudio as per upstream's
> "PerfectSetup", and such changes may come to hardy-proposed eventually:
> http://ubuntuforums.org/showthread.php?p=4928900
>
>
You can find Hardy builds of flash 10 for Ubuntu on my PPA. More than
likely you will want to download libflashsupport and flash 10 from that
repo since there will be other things pushed to there and its very
possible gonna break your system. Flash works as expected nothing on
that link ATM is broken.
https://edge.launchpad.net/~gnomefreak/+archive
Remember this is testing and should not have bugs reported against it

--
Sincerely Yours,
    John Vivirito

https://launchpad.net/~gnomefreak
https://wiki.ubuntu.com/JohnVivirito
Linux User# 414246

Not sure if we still want examples/output on this bug, but it's nearly a show-stopper for me. Please see attached for core debug and pulseaudio version. Speaking of that... it took for EVER to return results from pulseaudio --version and returned some funky errors while it was at it.

Jeff Fortin Tam (kiddo) wrote :

oh wait. I just tried Con's nspluginwrapper package for i386 https://bugs.launchpad.net/ubuntu/+source/pulseaudio/+bug/192888/comments/39

my setup is with libflashsupport, flash 9, pulseaudio and his nspluginwrapper i386 package. It works now, I don't have epiphany crashing all the time when I close a tab with playing contents, and I can be listening to music with rhythmbox at the same time, without any hacks in my audio configuration. Tested multiple youtube videos and tried as hard as I could to make it crash, but the damn thing seems stable.

This is one more vote for the nspluginwrapper solution. To hell with it, it's a hack (less so than uninstalling pulseaudio) but it *works*.

Jeff Fortin Tam (kiddo) wrote :

nevermind. I tried with the nsplugin trick, (with combinations of flash 9 or 10), or without pulseaudio and libflashsupport (combinations of flash 9 or 10), and epiphany /still/ crashes pretty much all the times I close a tab that contains flash contents. I'm wondering if it's a separate issue.

Alexander Jones (alex-weej) wrote :

Have the alsalib packages been backported to Hardy yet? Still getting
grey boxes (i.e. the plugin crashes) with Adobe Flash Player 10 and
PA.

Vincent Tschanz (fogia) wrote :

Problem is still here.

Fresh install of Hardy with all latest updates.

Step to reproduce :
Use firefox with flashplugin-nonfree WITHOUT libflashssupport. You can watch more than 100 Dailymotion's videos without any crash.
Install libflashsupport : Firefox will crash between 2 and 15 videos.
Uninstall libflashsupport : everything is ok.

This bug is reproductible with Flashplugin 10 beta from Adobe labs. (follow the steps above) So I think the bug is in libflashsupport, not in flashplugin.

Vincent Tschanz (fogia) on 2008-07-03
Changed in libflashsupport:
status: Fix Released → Confirmed
dano (danoex) wrote :

Workaround:
After testing several alternatives, the only thing that worked was to leave open a tab with http://video.google.com/ , that I can navigate smoothly

I have no idea as it affects this, but it works for me

dano, thanks for the workaround. It's working!

Henry Wertz (hwertz) wrote :

     So I've generally just dealt with this, since firefox now at least has the option to reload it's tabs. My gentoo boxes do not crash with flash though -- now with flash10 or previously with flash9 (even when using libflashsupport, to get me audio over the network.) I never thought much of it, I mean, they're totally different distros.. I didn't think I'd track down the root difference.
      But, today I looked -- gentoo uses a different libflashsupport! It gets it from https://svn.revolutionlinux.com/MILLE/XTERM/trunk/libflashsupport/Tarballs/libflashsupport-1.2.tar.bz2

     I built it, installed it on my ubuntu system. No sound. It checks for pulse then esd by looking in /tmp/.pulse-[USER], /var/lib/run/pulse, and /tmp/.esd. So I put "export FLASH_FORCE_PULSEAUDIO=1" into my .bashrc. Sound, and virtually no crashes! I've managed to crash once, but I have bwin.de AND lepoint.fr up, no crashes, even if I play the vid on bwin.de. (As they say way up there --^ bwin or lepoint alone crash almost 100% of the time).

     Someone ought to take a look at this copy of libflashsupport, and either adapt it to ubuntu, or find what bug(s) it fixes compared to the 0pointer code. I suppose per the code from 05-16-2008, it might not be a 100% fix but it seems quite a bit more stable to me.

     Or, alternately, get flash10 into hardy... then of course libflashsupport can be ditched.

linovski (avelinorego) wrote :

Henry, it is working for me also. Thanks

No problem until now

(The steps, on a fresh Hardy install:

sudo apt-get install build-essential libpulse-dev libesd0-dev

wget libflashsupport-1.2.tar.bz2, tar xjf, make, make install

Here, NO need of "export FLASH_FORCE_PULSEAUDIO=1"
)

linovski (avelinorego) wrote :

Well, not so stable :(
Back to old state

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package libflashsupport - 1.9-0ubuntu2~hardy1

---------------
libflashsupport (1.9-0ubuntu2~hardy1) hardy-backports; urgency=low

  * Automated backport upload; no source changes.

libflashsupport (1.9-0ubuntu2) intrepid; urgency=low

  * debian/control: Conflict with flashplugin-nonfree versions older
    than intrepid's while allowing for backports (LP: #192888).

 -- Scott Kitterman <email address hidden> Fri, 11 Jul 2008 09:55:50 +0100

Changed in libflashsupport:
status: Confirmed → Fix Released
teledyn (garym-teledyn) wrote :

I get a repeatable crash by
1) start audacious

amidi-plug(i_backend.c:i_backend_load:107): loading backend '/usr/lib/audacious/Input/amidi-plug/ap-alsa.so'
amidi-plug(i_backend.c:i_backend_load:145): backend /usr/lib/audacious/Input/amidi-plug/ap-alsa.so (name 'alsa') successfully loaded

2) loading youtube like http://www.youtube.com/watch?v=-RisxckQlzc which jams (because the sound from audacious is still playing) -- before today's update of the backport of libflashsupport this was all that would happen, but ...

3) loading http://mises.org/story/3037 and attempting to scroll that page down, the browser crashes.

teledyn (garym-teledyn) wrote :

interesting ... http://mises.org/story/3037 crashes libflashsupport all by itself, just load it and scroll down, but here's what's really interesting: If I PURGE libflashsupport, that page still crashes, but the youtube page now plays concurrently with audacious!!

so what is it that libflashsupport actually does?

I just installed the upgraded from Hardy proposed. For Epiphany, it's even worse ! Before, it was crashing often with a flash content. Now, it crashes all the time !

Martin G Miller (mgmiller) wrote :

I just upgraded to the flash 10 in Hardy backports and don't have libflashsupport installed.
I can't even finish loading this page all by itself, I don't get the chance to scroll, it crashes Firefox while the page is loading. http://mises.org/story/3037
On the other hand, if I go to a youtube site and play the videos full screen, they are much better, almost normal.

Conn O Griofa (psyke83) wrote :

Martin & everyone,

Please, I would urge everyone to pay attention to this post to avoid further confusion.

This bug (#192888) is concerned with libflashsupport causing crashes on Flash v9. We are forced to use libflashsupport on Flash v9 to get it working with PulseAudio.

Since Flash v10 beta 1, Flash supports the pulse_pcm plugins, allowing us to get PulseAudio output *without* libflashsupport - this was the ideal configuration (see bug #198453).

There has now been a release of Flash v10 beta 2, which appears to be in "hardy-backports". It seems there is a bug in beta 2, causing several Flash-enabled pages to crash, *with or without libflashsupport or pulse_pcm*. Therefore, there appears to be a bug in Flash v10 beta 2 that is *not* related to this bug at all.

Martin (and anyone now using Flash 10), bug #247682 is related to your crashes with Flash v10. Please don't mark that bug as a duplicate of this one, it is *not* related.

teledyn (garym-teledyn) wrote :

Conn:

Doh-- you're right! I must have upgraded and not noticed (the downside of the auto-updates) because I do indeed have 10.0.1.218+10.0.0.525ubuntu1~hardy1

but then this doesn explain why the Listen widget on http://blog.teledyn.com says "You need Flash version 9,0,45 or above. Please upgrade" :(

but I guess that's a separate ticket.

Conn O Griofa (psyke83) wrote :

Hi everyone,

This doesn't have a satisfactory fix yet. Flash 10 does *not* libflashsupport, but it has stability issues unrelated to PulseAudio, that need fixing in Firefox. Therefore, for the time being, Flash 10 isn't an option.

That leaves us with Flash 9. The closest we got to mitigating this issue was Flash 9 + libflashsupport + nspluginwrapper (on 32bit machines), however, that did not prevent Flash crashes. Flash continued to crash using this combination, and while the Firefox process survived, Flash became "greyed out", and would not return until Firefox was restarted.

I recently browsed the home page for nspluginwrapper, and notice the release notes for the development version here: http://gwenole.beauchesne.info/en/blog/2008/07/06/nspluginwrapper_1.1.0

"Auto-restart plugins. The plugins system is now restarted when an error is encountered. This is not fully automatic though. i.e. if a plugin crashed, you have two options to restart it: (i) reload the page, (ii) wait for a refresh requested by the page (through some javascript or whatever triggers an NPP_New() call). You no longer have to restart the browser!"

I have successfully built and packaged this version (some minor modification of the Debian/Ubuntu patches were necessary). My observations: Firefox never crashes. When Flash crashes, a "ghost" window without any content appears with the title "nspluginwrapper" and closes very fast. Sometimes the Flash content continues playing without intervention, and other times I need to reload the page in Firefox - and Flash always returns.

This is an imperfect solution - nay, workaround - but it's the best we have so far! Perhaps the maintainer of nspluginwrapper (Rob Andrews) could updating nspluginwrapper for Intrepid (and also with i386), and then it can be backported to Hardy. Otherwise you can use/test my deb that I will now attach...

cameo73 (jeroen-brattinga) wrote :

I would really like to test this workaround, but I have some dependency issues:

dpkg: dependency problems prevent configuration of nspluginwrapper:
 nspluginwrapper depends on libgtk2.0-0 (>= 2.13.3); however:
  Version of libgtk2.0-0 on system is 2.12.9-3ubuntu4.
 nspluginwrapper depends on libpango1.0-0 (>= 1.21.3); however:
  Version of libpango1.0-0 on system is 1.20.5-0ubuntu1.

Any idea where I can get those newer versions?

Conn O Griofa (psyke83) wrote :

cameo73,

The package I previously uploaded was built on Intrepid, oops. I'm attaching the package built on Hardy now.

Mircea (tramir) wrote :

I can confirm having this plugin. Uninstalling libflshsupport did not help. Installing nspluginwrapper solved the crash problem (firefox did not sem to crash anymore), but as expected I lost the ability to play from other sound sources together with flash.

Mircea (tramir) wrote :

I can confirm having this plugin. Uninstalling libflashsupport did not help. Installing nspluginwrapper solved the crash problem (firefox did not sem to crash anymore), but as expected I lost the ability to play from other sound sources together with flash.

I'm a bit confused. Conn's package is for i386, whereas the wrapper is specifically for non-i386 architectures. In any case I can't install it on my core2duo machine to test it :(

cameo73 (jeroen-brattinga) wrote :

The combination libflashsupport + nswrapper-conn2 + flash 9 is indeed the most stable one (for me). I think the current (perceived) instability of Firefox/Flash (note that most people wouldn't know the difference) in Hardy is a real problem. I wouldn't be surprised that this has been a dealbreaker for people trying Ubuntu.

Note to Robert Persson: nswrapper is originally meant to run x86 plugins in x64 environments. But it also has the benefit of 'sandboxing' plugins, so they don't crash the browser in case of a seg fault in the plugin. That's why the (I presume slightly modified) Conn version works: it doesn't fix the real issue, but it provides a nice workaround (i.e. limiting the crash effects -- and now negating them entirely).

I personally hope this workaround will soon be released; especially since the currently available versions are (very) unstable.

I'd like to test the new package also, but I only have a 64-bit install
so the i386 wouldn't work for me, I don't think.

cameo73 wrote:
> The combination libflashsupport + nswrapper-conn2 + flash 9 is indeed
> the most stable one (for me). I think the current (perceived)
> instability of Firefox/Flash (note that most people wouldn't know the
> difference) in Hardy is a real problem. I wouldn't be surprised that
> this has been a dealbreaker for people trying Ubuntu.
>
> Note to Robert Persson: nswrapper is originally meant to run x86 plugins
> in x64 environments. But it also has the benefit of 'sandboxing'
> plugins, so they don't crash the browser in case of a seg fault in the
> plugin. That's why the (I presume slightly modified) Conn version works:
> it doesn't fix the real issue, but it provides a nice workaround (i.e.
> limiting the crash effects -- and now negating them entirely).
>
> I personally hope this workaround will soon be released; especially
> since the currently available versions are (very) unstable.
>
>

ski (skibrianski) wrote :

Ditto what Jeremy said. Conn, if you haven't convenient access to an amd64 machine, I'm happy to compile one for you.

I suspect that cameo73 may be right about the flash problem being a deal-breaker. The only time most of my friends see linux in operation on a workstation is when I try to show them something I've found on youtube. If you are in the habit of using linked in you will find that the audio player rarely works. Where do many of my friends spend a lot of their online time when they are not on facebook? You've guessed it. So yes, this is an extremely serious problem that, if it is not solved, will make it impossible ever to resolve bug #1.

At the moment, restarting firefox is such an inconvenience that I usually open the page I want to see in opera instead if it is important enough. If Conn's package means that I will only have to reload the page, then that would only be a huge improvement and much less of an embarrassment to Firefox and Ubuntu.

Until Conn's version is tested and released for both architectures this bug should be marked as critical priority IMO.

when i said linkedin above i meant myspace. some people (not me btw) think facebook is sad, but spending hours on linkedin would be quite something else :)

Download full text (5.7 KiB)

I built a 64-bit package of the new nspluginwrapper via the instructions
I was given, however when I installed it and then launched Firefox,
Firefox freezes instantly. You aren't even able to use the address bar
or click on anything.

The package that I built is attached, but I don't recommend anyone
install it unless they want to confirm it freezes Firefox.

Terminal output is below:

ERROR: ld.so: object '/usr/lib/libartsdsp.so.0' from LD_PRELOAD cannot
be preloaded:
ignored.
ERROR: ld.so: object '/usr/lib/libartsc.so.0' from LD_PRELOAD cannot be
preloaded:
ignored.

** Message: GetValue variable 1
(1)
** Message: GetValue variable 2
(2)
** Message: GetValue variable 1
(1)
** Message: GetValue variable 2
(2)
** Message: GetValue variable 1
(1)
** Message: GetValue variable 2
(2)
** Message: GetValue variable 1
(1)
** Message: GetValue variable 2
(2)
** Message: GetValue variable 1
(1)
** Message: GetValue variable 2
(2)
** Message: GetValue variable 1
(1)
** Message: GetValue variable 2
(2)
GCJ PLUGIN: thread 0x6228b0:
NP_GetMIMEDescription
GCJ PLUGIN: thread 0x6228b0: NP_GetMIMEDescription
return
GCJ PLUGIN: thread 0x6228b0:
NP_GetValue
GCJ PLUGIN: thread 0x6228b0: NP_GetValue: returning plugin
name.
GCJ PLUGIN: thread 0x6228b0: NP_GetValue
return
GCJ PLUGIN: thread 0x6228b0:
NP_GetValue
GCJ PLUGIN: thread 0x6228b0: NP_GetValue: returning plugin
description.
GCJ PLUGIN: thread 0x6228b0: NP_GetValue
return
ERROR: ld.so: object '/usr/lib/libartsdsp.so.0' from LD_PRELOAD cannot
be preloaded:
ignored.
ERROR: ld.so: object '/usr/lib/libartsc.so.0' from LD_PRELOAD cannot be
preloaded:
ignored.

*** NSPlugin Wrapper *** ERROR: NPP_New() invoke: Message type
invalid
** Message: GetValue variable 1
(1)
** Message: GetValue variable 2
(2)
** Message: GetValue variable 1
(1)
** Message: GetValue variable 2
(2)
** Message: GetValue variable 1
(1)
** Message: GetValue variable 2
(2) ...

Read more...

Conn O Griofa (psyke83) wrote :

Using nspluginwrapper is an imperfect solution. I have some good news on the situation, but it depends on other bugs getting fixed.

I mentioned in a previous post that Flash 10 beta 2 is unstable even without libflashsupport installed. This issue specific to the new Flash version is not PulseAudio related, and has been identified and fixed in Firefox upstream or our bug #239182 (and it seems will be fixed in xulrunner 1.9.0.2).

For Intrepid, this is the situation: as soon as xulrunner is patched or upgraded to 1.9.0.2 (bug #239182) and the proposed PulseAudio ALSA plugin configuration in bug #198453 gets implemented, Flash v10 beta 2 will work perfectly with no random crashes as reported in this bug or bug #239182. Furthermore, Flash will correctly use PulseAudio output without the need for libflashsupport (note that libflashsupport needs to remain uninstalled, as it will continue to cause problems, and the PulseAudio ALSA plugin replaces its function).

For Hardy, we could theoretically implement the same configuration as Intrepid, but we would need to upgrade libasound2 and libasound2-plugins (as well as Flash), because Hardy's older ALSA pcm_pulse plugins do not seem to forward sound properly to PulseAudio with many ALSA applications. Fixing Hardy is not so straightforward, as the newer libasound2 may cause regressions.

As it stands, we can easily fix this bug for Intrepid, but Hardy is more complicated. I would argue that we should implement the necessary changes in Intrepid for testing purposes ASAP, and consider the feasibility of applying the same configuration for Hardy later.

Intrepid users can follow this guide and test the patched xulrunner packages to easily implement the configuration I propose:
1. PulseAudio Fixes (distilled): http://ubuntuforums.org/showthread.php?t=866965
2. Patched xulrunner packages: http://ubuntuforums.org/showpost.php?p=5472028&postcount=33

That is excellent news. Thank you to all the people who have been working on this!

I see the sense in what Conn suggests about testing in Intrepid and backporting to Hardy at a later date. However I am concerned about how much time this is likely to take. The web browser is the single most important desktop application, the one that everyone uses even if they use nothing else. At the moment a huge amount of web content is off limits to firefox. This is a very serious breakage that patently merits some fairly radical tinkering if that is what it takes to fix it, and that merits it in a real hurry. At the moment I am finding that I have to open Opera whenever I want to view pages with flash content. How long is Jo/e User going to put up with having to do something like that before s/he reinstalls Windows?

Or to put it another way, how serious is the risk of breaking hardy through a poorly implemented upgrade of libasound compared to the undeniable fact that the web browser is already crippled?

Thomas Pifer (zero456) wrote :

Thanks for continuing to keep us up-to-date on the situation Conn and thanks to the Ubuntu and Mozilla developers as well. Hopefully this will finally fix most (if not all) of Ubuntu's Flash woes.

Did something change recently? I went from having this problem maybe once a day, to having to restart my browser every ten or fifteen minutes. 64-bit here.

I think however drastic the fix, at this point I hope it's done. I'll test whatever packages, just send the DEB's my way.

i as well experience this issue, as soon as i try to use any flash, i get froze for a bit, i have to wait 5 minutes before firefox comes alive again. I'm a noob to ubuntu, so bare with me.

This is quite a bug list and seems to impact a lot of aspects of major Ubuntu components. Is there a place we can go for a status other than the eye chart at the top of the bug?

alecwh (alecwh) wrote :

Conn: While I understand what you're saying, I would argue that this is a high priority bug, and should be fixed in Hardy AND Intrepid as soon as possible. This seriously affects the user's experience when browsing the web, especially websites like Youtube.

This bug has been around long enough; I say, put an end to it!

As stated above, my thanks go out to the ubuntu, firefox, and flash developers (probably others too) for working on this.

Lets get it working in Hardy.

I agree. I'm not ready to move to Intrepid yet, and I don't think anyone
wants to wait, especially considering Hardy is an LTS release and more
people will be using that than Intrepid for years to come.

alecwh wrote:
> Conn: While I understand what you're saying, I would argue that this is
> a high priority bug, and should be fixed in Hardy AND Intrepid as soon
> as possible. This seriously affects the user's experience when browsing
> the web, especially websites like Youtube.
>
> This bug has been around long enough; I say, put an end to it!
>
> As stated above, my thanks go out to the ubuntu, firefox, and flash
> developers (probably others too) for working on this.
>
> Lets get it working in Hardy.
>
>

Flash Player 10 is now release candidate. Final version can be expected soon. What are the plans for hardy, staying at version 9 or upgrading to 10? Will Adobe host the flash 9 installer on his website after 10 goes stable? I'm asking this because as far as I know flash 10 would solve this whole issue.

Alexander Jones (alex-weej) wrote :

Adobe Flash 10 will be in hardy-updates. It is not supported software,
so it is not subject to the same version stability rules.

4 months into the hardy releasy and six into this bug, and flash is
still not working. I've seen some possible fixes in this bugreport, but
no definitive solutions.
  I have seen many new users change back to Windows or to other distros
because of this bug. Sorry guys, but this really needs fixing... IMHO it
should be marked as *Critical*. It's sad to see newly converted users
leaving linux and ubuntu because they can't see youtube.
  I don't really understand the status of the affected packages, since I
see several fix released, but it's still not working. It would be great
if someone could explain this, because it's a bit confusing (especially
for someone trying to learn its ways around proper bug managing)

  But i have two questions from an average user's perspective:

  - Is there at least a recommended workaround for this ? If there is,
it deserves front and center attention on the bug report and on the wiki
at least (possibly also in the forums: "How to Fix your crashing Flash")

  - Is there any way to contribute to this ? Package testing ? Further
bug information ? Anything to speed this up ? (I don't think Ubuntu can
afford 4 more months of this, and we should all pitch in.)

  Thanks.

Explanation: Adobe sucks at implementing their own specification (the
"libflashsupport" extension API). It is *entirely* Adobe's fault that
Flash crashes all the time.

If you insist on "fixing" this, then the only solution is to stop
using libflashsupport, which removes the ability for it to use the
PulseAudio ALSA PCM properly, which means that either Flash or
PulseAudio, but not both, can use the ALSA output at any one time.
Uninstalling PulseAudio will mean that all ALSA applications can share
the ALSA device using the "DMix" ALSA daemon, which is handled
automatically.

In short, "sudo apt-get remove libflashsupport pulseaudio", go to
System -> Preferences -> Sound and change all of your devices from
PulseAudio to a physical ALSA device of your choice to set GStreamer
applications using ALSA directly, run "asoundconf unset-pulseaudio" to
unset the Pulse PCM as the default ALSA output. You are back in Gutsy
territory, have a nice day.

ski (skibrianski) wrote :

I'm surprised you all are still having trouble - I'm having none whatsoever here... Maybe the difference is I'm running on amd64 here, and you all are on x86?? Flash crashes for me maybe once every week or two, at which point I just restart firefox, so it's a *very* minor bug for me at the moment. What's different? Did you all do the ia32-libs stuff? That solved everything for me - maybe that package doesn't exist on x86?

Conn O Griofa (psyke83) wrote :

Alexander,

I have trouble understanding why you seem to believe libflashsupport is still necessary. Since beta 1, Flash 10 is compatible with PulseAudio sans libflashsupport, as long as you set the correct PulseAudio device as per bug #198453 (which should be considered mandatory for a proper PulseAudio setup anyway).

This could be fixed immediately in Intrepid, and could be fixed with a minimum effort in Hardy (it's necessary to upgrade or backport patches in alsa-lib 1.0.16 due to bugs in Hardy's version).

Alexander Jones (alex-weej) wrote :

Then this bug should be closed or its description updated. Please!

> Since beta 1, Flash 10 is compatible with PulseAudio
> sans libflashsupport, as long as you set the correct PulseAudio device
> as per bug #198453 (which should be considered mandatory for a proper
> PulseAudio setup anyway).

Yes! It works. I agree with Alexander, it should be present in the bug
description.

Conn, just one question. Along the way, the packages from
https://launchpad.net/~gnomefreak/+archive , created by John Vivirito,
that fix a couple of bugs in pulse audio (?). Are these still required
as part of the fix ? Or just correctly configuring asoundrc ?

Thanks!

So, how would an Ubuntu Hardy user upgrade Flash from 9 to 10 (in order
to fix this bug)?

Can a tutorial/wiki be setup for this?

On Tue, 2008-08-12 at 22:10 +0000, alecwh wrote:
> So, how would an Ubuntu Hardy user upgrade Flash from 9 to 10 (in order
> to fix this bug)?
>
> Can a tutorial/wiki be setup for this?
>

Just enable hardy-backports for multiverse. This line on
your /etc/apt/sources.list should suffice:

deb http://de.archive.ubuntu.com/ubuntu/ hardy-backports restricted main
multiverse universe

Conn O Griofa (psyke83) on 2008-08-13
description: updated
Conn O Griofa (psyke83) wrote :

Alexander Jones: I have updated the description of the bug, hopefully things are clearer now.

Alfredo & alecwh: nope, that won't work. Flash 10 does not exist in any of the Hardy repositories as of today, as it was reverted to Flash 9 (you'd notice if you looked closely at the version: 10.0.1.218+10.0.0.525ubuntu1~hardy1+really9.0.124.0ubuntu2).

An unofficial fix is to use the settings in bug #198453, ensure libflashsupport is not installed and install flashplugin-nonfree, libasound2 and libasound2-plugins from the Intrepid repository. That can cause problems, naturally, but in practice it should work. It's more complicated for 64bit users.

Hardy-backports doesn't seems to solve the problem in Epiphany (I didn't tried Firefox but it should be the same)

I can confirm that Flash 10 RC still crashes my firefox even though I created /etc/.asoundrc as described and removed libflashsupport. A very "reliable" test site seems to be www.tivoli.dk.

Sorry, I meant /etc/asound.conf.

Conn O Griofa (psyke83) wrote :

Alexander Hunziker,

Yes, that site crashes here too, but it's not related to libflashsupport - you're now experiencing a bug in Firefox. Flash 10 has a new feature called "windowless mode", and Firefox's windowless mode support is buggy (newer versions of swfdec with windowless mode also cause identical crashes). See: http://blogs.adobe.com/penguin.swf/2008/07/addessing_wmode_crashes.html

This issue should be fixed in xulrunner 1.9.0.2, and backported packages are available for Hardy. See bug #239182.

So, you should:
1. Keep the /etc/asound.conf
2. Upgrade the xulrunner-1.9 and xulrunner-1.9-gnome-support packages from Felix Geyer's PPA: https://bugs.launchpad.net/ubuntu/+source/firefox-3.0/+bug/239182/comments/15
3. Check http://www.tivoli.dk

If you're using 32bit Ubuntu, that site should work correctly (using patched xulrunner, confirmed to work without crashes here). If you're using 64bit, you may also need a newer version of nspluginwrapper that supports "windowless mode".

Conn, you were right, I was experiencing another bug. The site shows without crashes using the xulrunner builds from the PPA.

On 2008-08-13 at 12:20 -0000, Conn wrote:

> Yes, that site crashes here too, but it's not related to libflashsupport
> - you're now experiencing a bug in Firefox. Flash 10 has a new feature
> called "windowless mode", and Firefox's windowless mode support is buggy
> (newer versions of swfdec with windowless mode also cause identical
> crashes). See:
> http://blogs.adobe.com/penguin.swf/2008/07/addessing_wmode_crashes.html

Adobe just posted a workaround:
http://blogs.adobe.com/penguin.swf/2008/08/windowless_mode_fix.html

root@foo:~# cat /etc/adobe/mms.cfg
WindowlessDisable=true

worksforme

Conn O Griofa (psyke83) wrote :

Michael,

You're correct, but you reported in the wrong bug (wmode crashes are unrelated to libflashsupport and PulseAudio, see bug #239182). It still doesn't fix libflashsupport - but hey, that's ok, because....

Flash, Firefox and PulseAudio instability can be resolved completely with the following fixes:
1. Bug #192888: Remove libflashsupport
2. Bug #198453: Set the proper ALSA configuration (ensuring you also have libasound2-plugins installed)
3. Bug #239182: Update to Flash 10 RC, and set the proper /etc/adobe.cfg configuration (the updated flashplugin-nonfree deb in my PPA sets this configuration already)

Alexander Jones wrote:
> Explanation: Adobe sucks at implementing their own specification (the
> "libflashsupport" extension API). It is *entirely* Adobe's fault that
> Flash crashes all the time.
>
> If you insist on "fixing" this, then the only solution is to stop
> using libflashsupport, which removes the ability for it to use the
> PulseAudio ALSA PCM properly, which means that either Flash or
> PulseAudio, but not both, can use the ALSA output at any one time.
> Uninstalling PulseAudio will mean that all ALSA applications can share
> the ALSA device using the "DMix" ALSA daemon, which is handled
> automatically.
>
I'm sorry, but this is nonsense. Flash works fairly well with Opera and
it doesn't seem to have any trouble negotiating access to the sound device.

But then again, it actually doesn't matter whose "fault" it is. Nothing
great in this world was ever built out of excuses. No commercial
product. Nothing. Please let's not have any more of this "It's Adobe's
fault" stuff. Will that make my browser work? Will it make Ubuntu a
viable desktop operating system?

There seem to be a lot of people for whom this bug seems to be fixed by
an upgrade to Flash 10 or whatever. Unfortunately that isn't the case
for me. I "upgraded" to 10 and I'm still spending my browsing hours
looking at blank rectangles.

Conn O Griofa (psyke83) wrote :

Sorry for the duplication, but there has been some overlapping discussion between this bug and bug #198453.

If you look at post https://bugs.launchpad.net/ubuntu/+source/pulseaudio/+bug/198453/comments/109 and
https://bugs.launchpad.net/ubuntu/+source/pulseaudio/+bug/198453/comments/111 (for 64bit users, thanks to Shot for the assistance), testing packages are available that essentially solve the (dire) situation with Flash and PulseAudio. Provided that we can backport/SRU the necessary packages for Hardy, and Flash 10 final comes soon, this bug is now completely fixable.

I have been running with this configuration for the past two days, and I haven't seen a single crash in Firefox or Flash. And yes, Flash uses PulseAudio, so there should be no more audio mixing conflicts.

Has anything changed recently?

I reported a while ago that something made this bug happen much more
common for me.

Now, as of today, it's even worse, as EVERY flash video with sound
freezes Firefox beyond control. 64-bit here.

Conn wrote:
> Sorry for the duplication, but there has been some overlapping
> discussion between this bug and bug #198453.
>
> If you look at post https://bugs.launchpad.net/ubuntu/+source/pulseaudio/+bug/198453/comments/109 and
> https://bugs.launchpad.net/ubuntu/+source/pulseaudio/+bug/198453/comments/111 (for 64bit users, thanks to Shot for the assistance), testing packages are available that essentially solve the (dire) situation with Flash and PulseAudio. Provided that we can backport/SRU the necessary packages for Hardy, and Flash 10 final comes soon, this bug is now completely fixable.
>
> I have been running with this configuration for the past two days, and I
> haven't seen a single crash in Firefox or Flash. And yes, Flash uses
> PulseAudio, so there should be no more audio mixing conflicts.
>
>

dano (danoex) wrote :

2008/8/27 Jeremy LaCroix <email address hidden>

> Has anything changed recently?
>
> I reported a while ago that something made this bug happen much more
> common for me.
>
> Now, as of today, it's even worse, as EVERY flash video with sound
> freezes Firefox beyond control. 64-bit here.
>
> Conn wrote:
> > Sorry for the duplication, but there has been some overlapping
> > discussion between this bug and bug #198453.
> >
> > If you look at post
> https://bugs.launchpad.net/ubuntu/+source/pulseaudio/+bug/198453/comments/109and
> >
> https://bugs.launchpad.net/ubuntu/+source/pulseaudio/+bug/198453/comments/111(for 64bit users, thanks to Shot for the assistance), testing packages are
> available that essentially solve the (dire) situation with Flash and
> PulseAudio. Provided that we can backport/SRU the necessary packages for
> Hardy, and Flash 10 final comes soon, this bug is now completely fixable.
> >
> > I have been running with this configuration for the past two days, and I
> > haven't seen a single crash in Firefox or Flash. And yes, Flash uses
> > PulseAudio, so there should be no more audio mixing conflicts.
> >
> >
>
> --
> firefox crashes on flash contents when using libflashsupport
> https://bugs.launchpad.net/bugs/192888
> You received this bug notification because you are a direct subscriber
> of the bug.
>

This workaround fix all my flash problems

························································
Elimina nspluginwrapper

$ sudo apt-get remove nspluginwrapper

* Elimina paquetes obsoletos y ficheros de configuracion:

$ sudo apt-get remove libflashsupport
$ sudo rm ~/.pulse/* ~/.asoundrc* /etc/asound.conf

* Instala las siguientes dependencias:

$ sudo apt-get install padevchooser libao-pulse libasound2-plugins
libsdl1.2debian-pulseaudio

* Añade las siguientes lineas a tu fichero /etc/apt/sources.list:

# PulseAudio Fixes - http://ubuntuforums.org/showthread.php?p=5587712
deb http://ppa.launchpad.net/psyke83/ubuntu hardy main
deb-src http://ppa.launchpad.net/psyke83/ubuntu hardy main

* Actualiza la lista de repositorios y despues actualiza tu sistema:

$ sudo apt-get update
$ sudo apt-get upgrade

* Fija Pulse Audio como el dispositivo ALSA por defecto (esto ejecutalo como
tu usuario normal, no como root):

$ asoundconf set-pulseaudio
$ echo "default_driver=pulse" >~/.libao

* Ve a Sistemas > Preferencias > Sonido y en todos los checkbox fijalos a
"Auto Detectar".
························································

--
Daniel Vásquez - Webmaster Revista Observaciones Filosóficas - DanoEX Chile
http://www.danoex.net/

Thank you, but I'm not installing anything from other repositories or
packages not in the repositories, I'm keeping my installation of Ubuntu
to what the Ubuntu devs put in the default repositories, because I want
to make sure this is fixed without having to go through hoops.

I'm hoping an update comes in on its own soon to fix all these issues.

dano wrote:
> 2008/8/27 Jeremy LaCroix <email address hidden>
>
>
>> Has anything changed recently?
>>
>> I reported a while ago that something made this bug happen much more
>> common for me.
>>
>> Now, as of today, it's even worse, as EVERY flash video with sound
>> freezes Firefox beyond control. 64-bit here.
>>
>> Conn wrote:
>>
>>> Sorry for the duplication, but there has been some overlapping
>>> discussion between this bug and bug #198453.
>>>
>>> If you look at post
>>>
>> https://bugs.launchpad.net/ubuntu/+source/pulseaudio/+bug/198453/comments/109and
>>
>> https://bugs.launchpad.net/ubuntu/+source/pulseaudio/+bug/198453/comments/111(for 64bit users, thanks to Shot for the assistance), testing packages are
>> available that essentially solve the (dire) situation with Flash and
>> PulseAudio. Provided that we can backport/SRU the necessary packages for
>> Hardy, and Flash 10 final comes soon, this bug is now completely fixable.
>>
>>> I have been running with this configuration for the past two days, and I
>>> haven't seen a single crash in Firefox or Flash. And yes, Flash uses
>>> PulseAudio, so there should be no more audio mixing conflicts.
>>>
>>>
>>>
>> --
>> firefox crashes on flash contents when using libflashsupport
>> https://bugs.launchpad.net/bugs/192888
>> You received this bug notification because you are a direct subscriber
>> of the bug.
>>
>>
>
> This workaround fix all my flash problems
>
> ························································
> Elimina nspluginwrapper
>
> $ sudo apt-get remove nspluginwrapper
>
> * Elimina paquetes obsoletos y ficheros de configuracion:
>
> $ sudo apt-get remove libflashsupport
> $ sudo rm ~/.pulse/* ~/.asoundrc* /etc/asound.conf
>
> * Instala las siguientes dependencias:
>
> $ sudo apt-get install padevchooser libao-pulse libasound2-plugins
> libsdl1.2debian-pulseaudio
>
> * Añade las siguientes lineas a tu fichero /etc/apt/sources.list:
>
> # PulseAudio Fixes - http://ubuntuforums.org/showthread.php?p=5587712
> deb http://ppa.launchpad.net/psyke83/ubuntu hardy main
> deb-src http://ppa.launchpad.net/psyke83/ubuntu hardy main
>
> * Actualiza la lista de repositorios y despues actualiza tu sistema:
>
> $ sudo apt-get update
> $ sudo apt-get upgrade
>
> * Fija Pulse Audio como el dispositivo ALSA por defecto (esto ejecutalo como
> tu usuario normal, no como root):
>
> $ asoundconf set-pulseaudio
> $ echo "default_driver=pulse" >~/.libao
>
> * Ve a Sistemas > Preferencias > Sonido y en todos los checkbox fijalos a
> "Auto Detectar".
> ························································
>
>

clickwir (clickwir) wrote :

There looks like theres a lot of work going on with this, and I really appreciate it. I don't know if this is useful information or not, but I notice npviewer.bin crashing more often if I try to play two things with flash at the same time. Like on the same page or different tabs.

I'm running Intrepid alpha, latest updates as of right now. 64bit.

Alexander Sack (asac) wrote :

\sh, can you remove libflashsupport.so from ia32-libs too? (probably just missed in the recent intrepid upload). Thanks!

Changed in ia32-libs:
assignee: nobody → shermann
importance: Undecided → High
status: New → Triaged
Alexander Sack (asac) wrote :

removing libflashsupport.so from ia32-libs has already been dragged for such a long time. milestoning the removal of libflashsupport.so for beta (but please upload asap anyway).

Changed in ia32-libs:
milestone: none → ubuntu-8.10-beta
Alexander Sack (asac) wrote :

making libflashsupport.so removal from ia32-libs release critical so the RM get that on the radar.

Stephan Ruegamer (sadig) wrote :

2.2ubuntu13 will not have libflashsupport.so anymore :)
I'm just waiting for some new results of new flashplugin10 to add more libs used by that package eventually.

Changed in ia32-libs:
status: Triaged → In Progress
Conn O Griofa (psyke83) wrote :

Stephen Hermann,

As we discussed, we're going to need libasound2-plugins within ia32-libs as well, due to the PA ALSA plugins.

When you set the the default ALSA device to PulseAudio (via "asoundconf set-pulseaudio"), the following occurs:

1. You launch an ALSA application.
2. The ALSA application looks in /etc/asound.conf or ~.asoundrc to determine the proper ALSA device, etc.
3. The PulseAudio ALSA plugins are used.

As you can see, the necessary libraries are part of libasound2-plugins:

conn@dimension:~/work$ dpkg -L libasound2-plugins | grep pulse.so
/usr/lib/alsa-lib/libasound_module_conf_pulse.so
/usr/lib/alsa-lib/libasound_module_ctl_pulse.so
/usr/lib/alsa-lib/libasound_module_pcm_pulse.so

When you run a 32-bit application, it will look for the 32-bit libraries, correct? We may need other libraries in ia32-libs due to PulseAudio, but "libasound2-plugins" we need for certain.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package ia32-libs - 2.2ubuntu13

---------------
ia32-libs (2.2ubuntu13) intrepid; urgency=low

  * fetch-and-build:
    + added lib: (LP: #271392)
      - libxcb-render-util0
      - libxcb-render0
    + removed lib:
      - libflashsupport (LP: #192888)

 -- Stephan Hermann <email address hidden> Wed, 17 Sep 2008 10:01:35 +0000

Changed in ia32-libs:
status: In Progress → Fix Released

The update came in today, and Firefox still crashes on every other page
with flash content. Firefox is completely unusable.

Launchpad Bug Tracker wrote:
> This bug was fixed in the package ia32-libs - 2.2ubuntu13
>
> ---------------
> ia32-libs (2.2ubuntu13) intrepid; urgency=low
>
> * fetch-and-build:
> + added lib: (LP: #271392)
> - libxcb-render-util0
> - libxcb-render0
> + removed lib:
> - libflashsupport (LP: #192888)
>
> -- Stephan Hermann <email address hidden> Wed, 17 Sep 2008 10:01:35 +0000
>
> ** Changed in: ia32-libs (Ubuntu Intrepid)
> Status: In Progress => Fix Released
>
>

Jeremy LaCroix wrote:
> The update came in today, and Firefox still crashes on every other page
> with flash content. Firefox is completely unusable.
>
I second this. A week or two ago I installed the fix that Conn posted,
which I assume is the same one Jeremy is talking about, and I still find
that I have to crank up Opera to see Flash stuff. I might get to watch
two or three YouTube videos in Firefox before it crashes if I'm lucky.

Ken Foskey (foskey) wrote :

I get zero flash videos ever and I have not got any for a while. Firefox does not crash however.

Firefox is exceptionally slow over the last week.

--
Ken Foskey

Remember http://www.ride2work.com.au/ 15th October 2008

ktp420 (ktp420) wrote :

Another testcase in which npviewer.bin stops when starting to play another clip....

goto dialbo III website and click on to see different skill and once one is done playing the next one should start but npviewer.bin process stops/crashes/quites...no npviewer.bin process and no flash on the page.

http://www.blizzard.com/diablo3/characters/witchdoctor.xml

ktp420 (ktp420) wrote :

bug #272286 might have found why npviewer.bin is so unstable.

ktp420 (ktp420) wrote :

you can disable windowless mode in the flash plugin by adding following to /etc/adobe/mms.cfg
   WindowlessDisable=true

Alexander Sack (asac) wrote :

not a firefox issue.

Changed in firefox:
status: Incomplete → Invalid
ktp420 (ktp420) wrote :

I lost audio in flash after recent update...now flash will not play sound if I have other apps playing sounds using pulseaudio.

alecwh (alecwh) wrote :

Can someone offer an update on this issue, and the progress of fixing it? Above (at the top), it says that fixes were already released, but others and myself are still having issues. Sorting through all these comments is painful.

Also, because the FeatureFreeze for Intrepid was on Aug 28th, will a fix (or upgrade to Flash 10 RC) make it to Intrepid? If not, I urge Ubuntu Developers to make an exception. This bug will seriously detract regular users from using Ubuntu. Probably the most used application - Firefox - is completely unstable with a content medium used EVERYWHERE on the net. To me, this seems like a disaster!

Thanks in advance for responses, and thanks to all the developers and programmers working on this bug.

wvarner (winshipvarner) wrote :

alecwh,

I was having the same problems with Flash on Hardy as you were, so I recently went ahead and updated my system to Intrepid (in part because I was continuously annoyed with this bug). From my experience it appears that this problem has been entirely fixed for 8.10 (at least on my i386 machine) - I've been surfing flash embedded websites for the past couple of days, and I've yet to have a single unwanted crash. Yay!

The setup I have is straightforward: Flash has been updated to 10.0.1.218+10.0.0.525ubuntu1, libflashsupport is uninstalled, and I don't have anything like nswrapper installed (which was mentioned above as a possible fix, but never seemed to work for me).

So it appears your problems will be fixed when intrepid comes out - which is just around the corner!

With regard to alecwh's request above, could I suggest that a page about this issue be created, perhaps on the ubuntu wiki, explaining what the problem is and what procedures are currently believed to resolve it?

Ascertaining what the problem is is getting extremely difficult, given that pulseaudio, libflashsupport and flash 9 (not 10) seem to have been involved in flash/firefox misbehaviour at some point, yet don't seem to be any more, despite the fact that the problem persists. To be honest, I have no idea which bug I am dealing with any more when flash continues to pack out on me every day. This means contributing meaningfully to bug reports is getting pretty hard.

Likewise I suggesting that the procedures that are supposed to solve the problem be described simply at this page, such as the one involving the packages conn uploaded not too long ago, so that their success or failure can be more easily reported, perhaps with a separate bug report for each procedure. I know it is not standard practice to have bug reports for things that are not yet part of Ubuntu, but I think we have an exceptionally serious situation here.

@warner: 32-bit or 64-bit?

Michael Rooney (mrooney) wrote :

On Sun, Sep 28, 2008 at 11:52 AM, Robert Persson
<email address hidden> wrote:
> With regard to alecwh's request above, could I suggest that a page about
> this issue be created, perhaps on the ubuntu wiki, explaining what the
> problem is and what procedures are currently believed to resolve it?

It is a wiki so, why not create it, stub out the basic structure you
want to see, and link here so people can fill it in. I would also
highly recommend that you send an email linking to it explaining your
intention for it, to <email address hidden> and
<email address hidden>. I think this can help you and Ubuntu
along! Just remember with free software, if you are having an issue,
you are the best person to put some work into it, instead of expecting
people less affected than you to care more about it :)

You also may want to check out Intrepid as someone else mentioned. If
some of your issues are solved there then the scope of the wiki page
might change. But still, I think you have a good idea and would
recommend going through with it, or at least emailing those two lists
together and asking for their suggestions on how to proceed.

Acting on Robert Persson's suggestion, I have created an Ubuntu Wiki
page that I hope will be populated with information and fixes:

https://help.ubuntu.com/community/FirefoxFlashCrashes

The wiki page only contains a brief template, introduction, and problem
description. I don't know much about this specific bug, the packages
that cause it, or even which fix proposed will work, so I can't add much
beyond that.

PLEASE go to the wiki page and contribute what you can. Hopefully, this
can be used as a reference for the problem, and will significantly
reduce confusion in this discussion.

- alecwh

alecwh (alecwh) wrote :

> It is a wiki so, why not create it, stub out the basic structure you
> want to see, and link here so people can fill it in. I would also
> highly recommend that you send an email linking to it explaining your
> intention for it, to <email address hidden> and
> <email address hidden>. I think this can help you and Ubuntu
> along! Just remember with free software, if you are having an issue,
> you are the best person to put some work into it, instead of expecting
> people less affected than you to care more about it :)
>

I have just created the wiki page, and I have dispatched emails to those
lists with the appropriate information. Here is the wiki:
https://help.ubuntu.com/community/FirefoxFlashCrashes

Please contribute!

Mike Rooney wrote:
> Just remember with free software, if you are having an issue,
> you are the best person to put some work into it, instead of expecting
> people less affected than you to care more about it :)
>
I do put effort into free software, for instance by trying to file
informative bug reports when I hit a problem. However it is not
reasonable to expect me to create an informative web page about
something I have already made it clear I just don't understand. I am
also about to become busy because I am starting a new job tomorrow and I
won't have time for a lot of messing about with software. I do what I
can do. Please don't put me down for not doing more than that. The above
comment is patronising. If you want ordinary users to stop filing bug
reports or seeking help on the forums, this is the way to go about it.

Conn O Griofa (psyke83) wrote :

I've edited that wiki page to describe the situation - please, try to understand the complexity in getting all the pieces working with Hardy. The focus must be on Intrepid *first*, and when all the issues are ironed out, then it can be considered for Hardy.

If you're using Hardy, you can get everything working "unofficially" by looking at the guide I posted on the forums and using my PPA - it's linked to the wiki page.

Let's try not to pollute the bug reports with anything except information useful for the developers. Idle chat, speculation and complaints are better reserved for the forums or elsewhere.

Conn wrote:
> If you're using Hardy, you can get everything working "unofficially" by
> looking at the guide I posted on the forums and using my PPA - it's
> linked to the wiki page.
This didn't work for me, but it's obviously working for some other
people. That's why I want to be able to be clear whether we are all
talking about the same bug.

Desabilitar FlashBlock para logar ver los archivos Flash

Alexander Sack (asac) wrote :

we wont be able to fix libflashsupport. setting task to wont fix. In intrepid libflashsupport should not be required anymore and since its even gone from ia32-libs there is no important bug we can fix here anymore.

Changed in libflashsupport:
status: Confirmed → Won't Fix
Daniel T Chen (crimsun) wrote :

flashplugin-nonfree now Conflicts with libflashsupport.

Changed in libflashsupport:
status: Confirmed → Fix Released
Michael Nagel (nailor) wrote :

can the last open tasks on this one be closed?

Alexander Jones (alex-weej) wrote :

I think so.

Michael Nagel (nailor) on 2009-01-22
Changed in libflashsupport:
status: New → Invalid
Changed in ia32-libs:
status: New → Invalid
John Vivirito (gnomefreak) wrote :

<email address hidden>:
Please do not post any type of non related info to bugs. All this does is spam the bug and is not desired.

teledyn (garym-teledyn) wrote :

I rather suspect that 'spam' is exactly what they'd had in mind, and
what we have witnessed is a whole new species of spam that may spell
the end of nice open-posting bug-reporting systems for free software :(

--
Gary Lawrence Murphy <garym at teledyn.com> =============================
Alice laughed: "There's no use trying, one can't believe impossible things."
"I daresay you haven't had much practice," said the Queen.

Download full text (6.5 KiB)

You're being a bit pessimistic here. To every problem, there is a solution.
For example you could implement a intelligent anti-spam system or do what
every American does: sue there asses off! :-p

2009/4/9 teledyn <email address hidden>

> I rather suspect that 'spam' is exactly what they'd had in mind, and
> what we have witnessed is a whole new species of spam that may spell
> the end of nice open-posting bug-reporting systems for free software :(
>
> --
> Gary Lawrence Murphy <garym at teledyn.com> =============================
> Alice laughed: "There's no use trying, one can't believe impossible
> things."
> "I daresay you haven't had much practice," said the Queen.
>
> --
> firefox crashes on flash contents when using libflashsupport
> https://bugs.launchpad.net/bugs/192888
> You received this bug notification because you are a direct subscriber
> of the bug.
>
> Status in “firefox” source package in Ubuntu: Invalid
> Status in “flashplugin-nonfree” source package in Ubuntu: Fix Released
> Status in “ia32-libs” source package in Ubuntu: Fix Released
> Status in “libflashsupport” source package in Ubuntu: Fix Released
> Status in “linux” source package in Ubuntu: Invalid
> Status in “pulseaudio” source package in Ubuntu: Invalid
> Status in firefox in Ubuntu Hardy: Invalid
> Status in flashplugin-nonfree in Ubuntu Hardy: Fix Released
> Status in ia32-libs in Ubuntu Hardy: Invalid
> Status in libflashsupport in Ubuntu Hardy: Fix Released
> Status in linux in Ubuntu Hardy: Invalid
> Status in pulseaudio in Ubuntu Hardy: Invalid
> Status in firefox in Ubuntu Intrepid: Invalid
> Status in flashplugin-nonfree in Ubuntu Intrepid: Fix Released
> Status in ia32-libs in Ubuntu Intrepid: Fix Released
> Status in libflashsupport in Ubuntu Intrepid: Won't Fix
> Status in linux in Ubuntu Intrepid: Invalid
> Status in pulseaudio in Ubuntu Intrepid: Invalid
> Status in “libflashsupport” source package in Baltix: Invalid
>
> Bug description:
> Testcase:
>
> use pulseaudio and libflashsupport together with flashplugin-nonfree in
> firefox.
>
> 1. navigate to youtube video
> 2. wait till sound plays
> 3. hit back button
> 4. hit forward
> 5. goto 2 if not yet crashed.
>
> the crash sometimes happens after 2 iterations ... and i can't remember
> that i ever made 10 :) ...
>
> =================
>
> Tested on two machines both with gutsy and hardy (on 32 bit x86): flash
> content very often crashes firefox (both of firefox-3.0 in hardy and older
> versions). I've just tried with other browsers, epiphany-browser crashes as
> well, and even konqueror from KDE (though it's not crashing at a whole,
> since it may run flash and other plugins as another user or something
> similar - I think at least - but it reports the crash of flash). I don't
> know exactly the package I should report this against, but as far as I can
> remember this issue presents since I started to play with pulseaudio: there
> is a wrapper lib to allow flash to play sound via PA right, so it CAN BE
> caused by this single issue instead of problem of the browser or the flash
> plugin itself?
>
> =================
> Workaround for early Hardy adopters:
>
> Manually uninstall the libflashsupport via...

Read more...

Heh ... y'know, this is EXACTLY what sendmail heads told me the day I
reported false-bounce spam, and what the drupal guys told me the day I
first reported referrer-spam, and then AGAIN when I first reported
robot-posted comment-spam, none of which have been yet adequately solved :)

anyway, this is all off topic.

>>>>> "J" == Jeroen <email address hidden> writes:

    J> You're being a bit pessimistic here. To every problem, there is
    J> a solution. For example you could implement a intelligent
    J> anti-spam system or do what every American does: sue there
    J> asses off! :-p

--
Gary Lawrence Murphy <garym at teledyn.com> =============================
Alice laughed: "There's no use trying, one can't believe impossible things."
"I daresay you haven't had much practice," said the Queen.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.